--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-0.17.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-0.17.0.xml::tm-0.17.0.01::gfouquet
--  This table stores "action" tests steps, i.e. steps with an action and expected result, which were formerly stored in TEST_STEP
CREATE TABLE ACTION_TEST_STEP (TEST_STEP_ID BIGINT NOT NULL COMMENT 'Shared key with TEST_STEP table', ACTION LONGTEXT NOT NULL COMMENT 'The step''s action', EXPECTED_RESULT LONGTEXT DEFAULT null NULL COMMENT 'The step''s expected result', ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT pk_action_step PRIMARY KEY (TEST_STEP_ID), CONSTRAINT fk_action_step_test_step FOREIGN KEY (TEST_STEP_ID) REFERENCES TEST_STEP(TEST_STEP_ID), CONSTRAINT fk_action_test_step_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.17.0.01', 'gfouquet', '../tm/tm.changelog-0.17.0.xml', NOW(), 1, '8:3605a3f2fdb2c5f88f12d05f99f657dd', 'createTable tableName=ACTION_TEST_STEP', 'This table stores "action" tests steps, i.e. steps with an action and expected result, which were formerly stored in TEST_STEP', 'EXECUTED', NULL, NULL, '4.17.2', '9340183720');

--  Changeset ../tm/tm.changelog-0.17.0.xml::tm-0.17.0.02::gfouquet
--  Data migration from TEST_STEP to ACTION_TEST_STEP
insert into ACTION_TEST_STEP (TEST_STEP_ID, ACTION, EXPECTED_RESULT, ATTACHMENT_LIST_ID) select TEST_STEP_ID, ACTION, EXPECTED_RESULT, ATTACHMENT_LIST_ID from TEST_STEP;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.17.0.02', 'gfouquet', '../tm/tm.changelog-0.17.0.xml', NOW(), 2, '8:5b3ee015db37a18baf9cf10b687b471e', 'sql', 'Data migration from TEST_STEP to ACTION_TEST_STEP', 'EXECUTED', NULL, NULL, '4.17.2', '9340183720');

--  Changeset ../tm/tm.changelog-0.17.0.xml::tm-0.17.0.03::gfouquet
--  Removes useless comlumns from TEST_STEP
ALTER TABLE TEST_STEP DROP FOREIGN KEY fk_test_step__attachment_list;

ALTER TABLE TEST_STEP DROP COLUMN ACTION;

ALTER TABLE TEST_STEP DROP COLUMN EXPECTED_RESULT;

ALTER TABLE TEST_STEP DROP COLUMN ATTACHMENT_LIST_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.17.0.03', 'gfouquet', '../tm/tm.changelog-0.17.0.xml', NOW(), 3, '8:f1d9345092fa7b2269da4794be68a972', 'dropForeignKeyConstraint baseTableName=TEST_STEP, constraintName=fk_test_step__attachment_list; dropColumn columnName=ACTION, tableName=TEST_STEP; dropColumn columnName=EXPECTED_RESULT, tableName=TEST_STEP; dropColumn columnName=ATTACHMENT_LIST_ID...', 'Removes useless comlumns from TEST_STEP', 'EXECUTED', NULL, NULL, '4.17.2', '9340183720');

--  Changeset ../tm/tm.changelog-0.17.0.xml::tm-0.17.0.04::gfouquet
--  This table stores "call" tests steps, i.e. steps which call an entire test case
CREATE TABLE CALL_TEST_STEP (TEST_STEP_ID BIGINT NOT NULL COMMENT 'Shared key with TEST_STEP table', CALLED_TEST_CASE_ID BIGINT NOT NULL COMMENT 'ID of called test case', CONSTRAINT pk_call_step PRIMARY KEY (TEST_STEP_ID), CONSTRAINT fk_call_step_test_step FOREIGN KEY (TEST_STEP_ID) REFERENCES TEST_STEP(TEST_STEP_ID), CONSTRAINT fk_call_step_called_test_case FOREIGN KEY (CALLED_TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.17.0.04', 'gfouquet', '../tm/tm.changelog-0.17.0.xml', NOW(), 4, '8:c840200146ebff14aaa673695e2c082c', 'createTable tableName=CALL_TEST_STEP', 'This table stores "call" tests steps, i.e. steps which call an entire test case', 'EXECUTED', NULL, NULL, '4.17.2', '9340183720');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

