--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-0.23.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-0.23.0.xml::tm-0.23.0.01::bsiri
--  remove ProjectManager and TestRunner from the ACL permission table
delete from ACL_GROUP_PERMISSION where ACL_GROUP_ID in 
			(select id from ACL_GROUP where qualified_name='squashtest.acl.group.tm.ProjectManager' 
			or qualified_name='squashtest.acl.group.tm.TestRunner');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.23.0.01', 'bsiri', '../tm/tm.changelog-0.23.0.xml', NOW(), 1, '8:dec41aae12984def474e0c8ba00d0414', 'sql', 'remove ProjectManager and TestRunner from the ACL permission table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183825');

--  Changeset ../tm/tm.changelog-0.23.0.xml::tm-0.23.0.02::bsiri
--  all users that were ProjectManager or TestRunner on anything are now TestEditor
update ACL_RESPONSIBILITY_SCOPE_ENTRY
			set ACL_GROUP_ID = (select id from ACL_GROUP where qualified_name='squashtest.acl.group.tm.TestEditor')
			where ACL_GROUP_ID in (select id from ACL_GROUP where qualified_name='squashtest.acl.group.tm.ProjectManager' 
									or qualified_name='squashtest.acl.group.tm.TestRunner');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.23.0.02', 'bsiri', '../tm/tm.changelog-0.23.0.xml', NOW(), 2, '8:df0ccbd27da3fa11f2252a61948a5150', 'sql', 'all users that were ProjectManager or TestRunner on anything are now TestEditor', 'EXECUTED', NULL, NULL, '4.17.2', '9340183825');

--  Changeset ../tm/tm.changelog-0.23.0.xml::tm-0.23.0.03::bsiri
--  remove ProjectManager and TestRunner from the existing acl groups
delete from ACL_GROUP
			where qualified_name='squashtest.acl.group.tm.ProjectManager' 
			or qualified_name='squashtest.acl.group.tm.TestRunner';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.23.0.03', 'bsiri', '../tm/tm.changelog-0.23.0.xml', NOW(), 3, '8:e8510b02716b7df4ca8bc71c30b7f762', 'sql', 'remove ProjectManager and TestRunner from the existing acl groups', 'EXECUTED', NULL, NULL, '4.17.2', '9340183825');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

