--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.1.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.01::gfouquet
--  Corrects status to BLOCKED in EXECUTION table
UPDATE EXECUTION SET EXECUTION_STATUS = 'BLOCKED' WHERE EXECUTION_STATUS='BLOQUED';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.01', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 1, '8:79711f5ccac1251f0be10867d4f9b8d9', 'update tableName=EXECUTION', 'Corrects status to BLOCKED in EXECUTION table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.02::gfouquet
--  Corrects status to BLOCKED in EXECUTION_STEP table
UPDATE EXECUTION_STEP SET EXECUTION_STATUS = 'BLOCKED' WHERE EXECUTION_STATUS='BLOQUED';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.02', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 2, '8:bb74182fc3b1d8ac8e7e5b5bb3bd1e65', 'update tableName=EXECUTION_STEP', 'Corrects status to BLOCKED in EXECUTION_STEP table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.03::gfouquet
--  Corrects status to BLOCKED in EXECUTION_STEP table
UPDATE ITERATION_TEST_PLAN_ITEM SET EXECUTION_STATUS = 'BLOCKED' WHERE EXECUTION_STATUS='BLOQUED';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.03', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 3, '8:2bdda49f84cdd5586893510ee798110d', 'update tableName=ITERATION_TEST_PLAN_ITEM', 'Corrects status to BLOCKED in EXECUTION_STEP table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.04::gfouquet
--  Adds an importance to test cases
ALTER TABLE TEST_CASE ADD IMPORTANCE VARCHAR(20) DEFAULT 'LOW' NOT NULL COMMENT 'The importance of the test case';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.04', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 4, '8:e6a1b1f7191a69c48f641e1e5f859c64', 'addColumn tableName=TEST_CASE', 'Adds an importance to test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.05::gfouquet
--  Adds a auto compute importance property to test cases
ALTER TABLE TEST_CASE ADD IMPORTANCE_AUTO BIT(1) DEFAULT 0 NOT NULL COMMENT 'Should the importance be automatically computed';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.05', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 5, '8:94a92b8fcfbf7311a600a96350337f6e', 'addColumn tableName=TEST_CASE', 'Adds a auto compute importance property to test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.06::gfouquet
--  Adds a TM database version number
INSERT INTO CORE_CONFIG (STR_KEY, VALUE) VALUES ('squashtest.tm.database.version', '1.1.0');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.06', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 6, '8:bbdcf879786a1e72a9b0c46f67ae75d7', 'insert tableName=CORE_CONFIG', 'Adds a TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.07::gfouquet
--  A tree node organizes resources. These are stored in the RESOURCE table
CREATE TABLE `RESOURCE` (RES_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'generated surrogate key', NAME VARCHAR(255) NOT NULL COMMENT 'Resource''s name', `DESCRIPTION` LONGTEXT DEFAULT null NULL COMMENT 'Resource''s description', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'Who created this requirement''s version', CREATED_ON datetime NOT NULL COMMENT 'When this requirement''s version was created', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Who modified this requirement''s version last', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'When this requirement''s version was last modified', CONSTRAINT PK_RESOURCE PRIMARY KEY (RES_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.07', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 7, '8:342f29e07b846b0a75c82fa8abc00bc7', 'createTable tableName=RESOURCE', 'A tree node organizes resources. These are stored in the RESOURCE table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.08::gfouquet
--  SIMPLE_RESOURCE stores "concrete" resources with a name and a description
CREATE TABLE SIMPLE_RESOURCE (RES_ID BIGINT NOT NULL COMMENT 'shared key with RESOURCE table', CONSTRAINT pk_simple_resource PRIMARY KEY (RES_ID), CONSTRAINT fk_resource FOREIGN KEY (RES_ID) REFERENCES RESOURCE(RES_ID));

ALTER TABLE REQUIREMENT_FOLDER ADD RES_ID BIGINT NULL COMMENT 'FK to SIMPLE_RESOURCE table';

ALTER TABLE REQUIREMENT_FOLDER ADD CONSTRAINT fk_req_folder_simple_resource FOREIGN KEY (RES_ID) REFERENCES SIMPLE_RESOURCE (RES_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.08', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 8, '8:17221cba8034de0f0634f1626b6f6c9d', 'createTable tableName=SIMPLE_RESOURCE; addColumn tableName=REQUIREMENT_FOLDER', 'SIMPLE_RESOURCE stores "concrete" resources with a name and a description', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.09::gfouquet
--  Moves requirement folder data into SIMPLE_RESOURCE table
insert into RESOURCE (RES_ID, NAME, DESCRIPTION, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON) 
			select f.RLN_ID, NAME, DESCRIPTION, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON
			from REQUIREMENT_LIBRARY_NODE n
			inner join REQUIREMENT_FOLDER f on n.RLN_Id = f.RLN_ID
			where n.DELETED_ON is null;

insert into SIMPLE_RESOURCE (RES_ID) 
			select res.RES_ID
			from REQUIREMENT_LIBRARY_NODE n
			inner join REQUIREMENT_FOLDER f on n.RLN_Id = f.RLN_ID
			inner join RESOURCE res on res.RES_ID = f.RLN_ID
			where n.DELETED_ON is null;

update REQUIREMENT_FOLDER 
			set RES_ID = RLN_ID
			where exists (select 1 from REQUIREMENT_LIBRARY_NODE where REQUIREMENT_LIBRARY_NODE.RLN_ID = REQUIREMENT_FOLDER.RLN_ID and DELETED_ON is null);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.09', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 9, '8:729b3829b5a9762ae664b759726487de', 'sql; sql; sql', 'Moves requirement folder data into SIMPLE_RESOURCE table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.10::gfouquet
--  Creates REQUIREMENT_VERSION table in which we store the versions of requirements
CREATE TABLE REQUIREMENT_VERSION (RES_ID BIGINT NOT NULL COMMENT 'shared key with RESOURCE table', REQUIREMENT_ID BIGINT NULL COMMENT 'FK to the requirement. Should not be null but is nullable because of cyclic association REQ - REQ_VER', `REFERENCE` VARCHAR(20) NULL COMMENT 'The requirement''s reference', VERSION_NUMBER INT DEFAULT 1 NULL COMMENT 'This requirement''s version number', CRITICALITY VARCHAR(50) DEFAULT 'UNDEFINED' NOT NULL COMMENT 'Requirement criticality. Althought this field is a variable character, the data will be the text representation of an enumeration', REQUIREMENT_STATUS VARCHAR(50) DEFAULT 'WORK_IN_PROGRESS' NOT NULL, ATTACHMENT_LIST_ID BIGINT NOT NULL COMMENT 'FK to a requirement''s list of attachments', CONSTRAINT pk_requirement_version PRIMARY KEY (RES_ID), CONSTRAINT fk_req_version_resource FOREIGN KEY (RES_ID) REFERENCES RESOURCE(RES_ID), CONSTRAINT fk_requirement_version_requirement FOREIGN KEY (REQUIREMENT_ID) REFERENCES REQUIREMENT(RLN_ID), CONSTRAINT fk_requirement_version_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

ALTER TABLE REQUIREMENT_VERSION ADD CONSTRAINT cu_version_of_requirement UNIQUE (REQUIREMENT_ID, VERSION_NUMBER);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.10', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 10, '8:75b1b57b1635f22bfb9db311487bb714', 'createTable tableName=REQUIREMENT_VERSION; addUniqueConstraint constraintName=cu_version_of_requirement, tableName=REQUIREMENT_VERSION', 'Creates REQUIREMENT_VERSION table in which we store the versions of requirements', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.11::gfouquet
--  Migrates requirement data into REQUIREMENT_VERSION table
insert into RESOURCE 
				(RES_ID, NAME, DESCRIPTION, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON) 
			select r.RLN_ID, NAME, DESCRIPTION, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON
			from REQUIREMENT_LIBRARY_NODE n
			inner join REQUIREMENT r on n.RLN_Id = r.RLN_ID
			where n.DELETED_ON is null;

insert into REQUIREMENT_VERSION 
				(RES_ID, REQUIREMENT_ID, REFERENCE, CRITICALITY, ATTACHMENT_LIST_ID) 
			select res.RES_ID, r.RLN_ID, REFERENCE, CRITICALITY, ATTACHMENT_LIST_ID
			from REQUIREMENT_LIBRARY_NODE n
			inner join REQUIREMENT r on n.RLN_Id = r.RLN_ID
			inner join RESOURCE res on res.RES_ID = r.RLN_ID
			where n.DELETED_ON is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.11', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 11, '8:09e0e1815b7746adbceb0863d16626b8', 'sql; sql', 'Migrates requirement data into REQUIREMENT_VERSION table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.12::gfouquet
--  Adds the 'latest version' relationship between REQUIREMENT and REQUIREMENT_VERSION tables
ALTER TABLE REQUIREMENT ADD CURRENT_VERSION_ID BIGINT NULL COMMENT 'FK to REQUIREMENT_VERSION linking to the requirement''s latest version. Should not be null but the column is nullable because of cyclic relationship between the tables.';

ALTER TABLE REQUIREMENT ADD CONSTRAINT fk_requirement_current_version FOREIGN KEY (CURRENT_VERSION_ID) REFERENCES REQUIREMENT_VERSION (RES_ID);

update REQUIREMENT r
			set CURRENT_VERSION_ID = (
				select RES_ID 
				from REQUIREMENT_VERSION rv 
				where rv.REQUIREMENT_ID = r.RLN_ID
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.12', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 12, '8:4d48b4d8f39e94e6c1e50c4fe6eb1ce5', 'addColumn tableName=REQUIREMENT; sql', 'Adds the ''latest version'' relationship between REQUIREMENT and REQUIREMENT_VERSION tables', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.13::gfouquet
--  Test Cases now cover Requirements versions. We create a new association table and populate it from TEST_CASE_REQUIREMENT_LINK
CREATE TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION (VERIFIED_REQ_VERSION_ID BIGINT NULL COMMENT 'FK to the verified requirement', VERIFYING_TEST_CASE_ID BIGINT NULL COMMENT 'FK to the verifying test case', CONSTRAINT fk_verifying_test_case FOREIGN KEY (VERIFYING_TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID), CONSTRAINT fk_verified_req_version FOREIGN KEY (VERIFIED_REQ_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID));

insert into TEST_CASE_VERIFIED_REQUIREMENT_VERSION (VERIFYING_TEST_CASE_ID, VERIFIED_REQ_VERSION_ID)
			select TEST_CASE_ID, RES_ID
			from TEST_CASE_REQUIREMENT_LINK tcrl
			inner join REQUIREMENT_VERSION rv on rv.REQUIREMENT_ID = tcrl.REQUIREMENT_ID;

ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION MODIFY VERIFIED_REQ_VERSION_ID BIGINT NOT NULL;

ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION MODIFY VERIFYING_TEST_CASE_ID BIGINT NOT NULL;

ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION ADD CONSTRAINT uc_tc_verifies_req_version UNIQUE (VERIFIED_REQ_VERSION_ID, VERIFYING_TEST_CASE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.13', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 13, '8:9c4699c8a8acaf98c44dd69ef58fef6e', 'createTable tableName=TEST_CASE_VERIFIED_REQUIREMENT_VERSION; sql; addNotNullConstraint columnName=VERIFIED_REQ_VERSION_ID, tableName=TEST_CASE_VERIFIED_REQUIREMENT_VERSION; addNotNullConstraint columnName=VERIFYING_TEST_CASE_ID, tableName=TEST_CA...', 'Test Cases now cover Requirements versions. We create a new association table and populate it from TEST_CASE_REQUIREMENT_LINK', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.14::gfouquet
--  Trashes the now useless TEST_CASE_REQUIREMENT_LINK table
ALTER TABLE TEST_CASE_REQUIREMENT_LINK DROP FOREIGN KEY fk_tc_req_tc;

ALTER TABLE TEST_CASE_REQUIREMENT_LINK DROP FOREIGN KEY fk_tc_req_req;

DROP TABLE TEST_CASE_REQUIREMENT_LINK;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.14', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 14, '8:bb06fbe90bd75bbe215e7966b280e55a', 'dropForeignKeyConstraint baseTableName=TEST_CASE_REQUIREMENT_LINK, constraintName=fk_tc_req_tc; dropForeignKeyConstraint baseTableName=TEST_CASE_REQUIREMENT_LINK, constraintName=fk_tc_req_req; dropTable tableName=TEST_CASE_REQUIREMENT_LINK', 'Trashes the now useless TEST_CASE_REQUIREMENT_LINK table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.15::bsiri
--  This table is the main table of the event logging system, in other words the history of a business entity. As for Squash TM
--  		version 1.1.0 and until further notice, we log here requirement modifications only. It may grows to log other entities in the future, ie test cases.
--  		Note : the application will fill this table itself, since we don't want triggers in the database.
CREATE TABLE REQUIREMENT_AUDIT_EVENT (EVENT_ID BIGINT AUTO_INCREMENT NOT NULL, REQ_VERSION_ID BIGINT NOT NULL COMMENT 'the ID of the target entity. As for 1.1.0 and until further notice, the target is always a requirement version.', EVENT_DATE datetime NOT NULL COMMENT 'the timestamp of the log entry', AUTHOR VARCHAR(255) NOT NULL COMMENT 'the login of the user who generated the event', CONSTRAINT PK_REQUIREMENT_AUDIT_EVENT PRIMARY KEY (EVENT_ID), CONSTRAINT fk_audit_event_requirement_version FOREIGN KEY (REQ_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.15', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 15, '8:44d2544f57717e78e4b98d69816653b7', 'createTable tableName=REQUIREMENT_AUDIT_EVENT', 'This table is the main table of the event logging system, in other words the history of a business entity. As for Squash TM
		version 1.1.0 and until further notice, we log here requirement modifications only. It may grows to log other entities in...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.16::bsiri
--  It is a child table of REQUIREMENT_AUDIT_EVENT. This table exists for the sole purpose of qualifying a given event in a creation event, as such its content is empty (the sheer presence
--  		of an entry in this table is sufficient)
CREATE TABLE REQUIREMENT_CREATION (EVENT_ID BIGINT NOT NULL COMMENT 'primary key, which is also a foreign key to REQUIREMENT_AUDIT_EVENT (they share that key : do not make this table autoincrement it).', CONSTRAINT PK_CREATION_EVENT PRIMARY KEY (EVENT_ID), CONSTRAINT fk_create_audit FOREIGN KEY (EVENT_ID) REFERENCES REQUIREMENT_AUDIT_EVENT(EVENT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.16', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 16, '8:6574b3e3b2628237cf94e751854f48c4', 'createTable tableName=REQUIREMENT_CREATION', 'It is a child table of REQUIREMENT_AUDIT_EVENT. This table exists for the sole purpose of qualifying a given event in a creation event, as such its content is empty (the sheer presence
		of an entry in this table is sufficient)', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.17::bsiri
--  This is a child table of REQUIREMENT_AUDIT_EVENT. This table will log updates on the target entity. Not every operations will be logged. 
--  			Note 1 : As for version 1.1.0 and until further notice for the sake of simplicity we log both the former and the new value. It may change in the future.
--  			Note 2 : For technical reasons this table exists in two flavors. The twin table is REQUIREMENT_LARGE_PROPERTY_CHANGE. This table will log standard attributes, 
--  			while the other one will log blobs.
CREATE TABLE REQUIREMENT_PROPERTY_CHANGE (EVENT_ID BIGINT NOT NULL COMMENT 'primary key, which is also a foreign key to REQUIREMENT_AUDIT_EVENT (they share that key : do not make this table autoincrement it).', OLD_VALUE VARCHAR(100) NULL, NEW_VALUE VARCHAR(100) NULL, PROPERTY_NAME VARCHAR(100) NULL, CONSTRAINT PK_PPT_CHANGE PRIMARY KEY (EVENT_ID), CONSTRAINT fk_PPT_change_audit FOREIGN KEY (EVENT_ID) REFERENCES REQUIREMENT_AUDIT_EVENT(EVENT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.17', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 17, '8:1d1e9e5f9fa68541dc488dc7721a3cbc', 'createTable tableName=REQUIREMENT_PROPERTY_CHANGE', 'This is a child table of REQUIREMENT_AUDIT_EVENT. This table will log updates on the target entity. Not every operations will be logged. 
			Note 1 : As for version 1.1.0 and until further notice for the sake of simplicity we log both the former a...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.18::bsiri
--  This is a child table of REQUIREMENT_AUDIT_EVENT. This table will log updates on the target entity. Not every operations will be logged. 
--  			Note 1 : As for version 1.1.0 and until further notice for the sake of simplicity we log both the former and the new value. It may change in the future.
--  			Note 2 : For technical reasons this table exists in two flavors. The twin table is REQUIREMENT_PROPERTY_CHANGE. This table will log blobs, 
--  			while the other one will log standard attributes.
CREATE TABLE REQUIREMENT_LARGE_PROPERTY_CHANGE (EVENT_ID BIGINT NOT NULL COMMENT 'primary key, which is also a foreign key to REQUIREMENT_AUDIT_EVENT (they share that key : do not make this table autoincrement it).', OLD_VALUE LONGTEXT DEFAULT null NULL, NEW_VALUE LONGTEXT DEFAULT null NULL, PROPERTY_NAME VARCHAR(100) NULL, CONSTRAINT PK_LARGE_PPT_CHANGE PRIMARY KEY (EVENT_ID), CONSTRAINT fk_lPPT_change_audit FOREIGN KEY (EVENT_ID) REFERENCES REQUIREMENT_AUDIT_EVENT(EVENT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.18', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 18, '8:309bef213b6d1d108841560a4246d15e', 'createTable tableName=REQUIREMENT_LARGE_PROPERTY_CHANGE', 'This is a child table of REQUIREMENT_AUDIT_EVENT. This table will log updates on the target entity. Not every operations will be logged. 
			Note 1 : As for version 1.1.0 and until further notice for the sake of simplicity we log both the former a...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.19::bsiri
--  Will immediately update the tables with the create_events of existing requirements.
insert into REQUIREMENT_AUDIT_EVENT (REQ_VERSION_ID, EVENT_DATE, AUTHOR) 
			select rv.RES_ID, CREATED_ON, CREATED_BY  
			from REQUIREMENT_VERSION rv 
			inner join RESOURCE r on r.RES_ID = rv.RES_ID;

insert into REQUIREMENT_CREATION (event_id) select event_id from REQUIREMENT_AUDIT_EVENT;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.19', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 19, '8:a1c790a9625973f23e6486620edb3ef5', 'sql; sql', 'Will immediately update the tables with the create_events of existing requirements.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.20::gfouquet
--  Remove obsolete columns from REQUIREMENT and REQUIREMENT_LIBRARY_NODE table. 
--  			Data is now in REQUIREMENT_VERSION and REQUIREMENT_FOLDER tables.
ALTER TABLE REQUIREMENT DROP COLUMN `REFERENCE`;

ALTER TABLE REQUIREMENT DROP COLUMN CRITICALITY;

ALTER TABLE REQUIREMENT DROP FOREIGN KEY fk_requirement_attachment_list;

ALTER TABLE REQUIREMENT DROP COLUMN ATTACHMENT_LIST_ID;

ALTER TABLE REQUIREMENT_LIBRARY_NODE DROP COLUMN NAME;

ALTER TABLE REQUIREMENT_LIBRARY_NODE DROP COLUMN `DESCRIPTION`;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.20', 'gfouquet', '../tm/tm.changelog-1.1.0.xml', NOW(), 20, '8:88439c6c1d08d203621902dd7c5b4700', 'dropColumn columnName=REFERENCE, tableName=REQUIREMENT; dropColumn columnName=CRITICALITY, tableName=REQUIREMENT; dropForeignKeyConstraint baseTableName=REQUIREMENT, constraintName=fk_requirement_attachment_list; dropColumn columnName=ATTACHMENT_L...', 'Remove obsolete columns from REQUIREMENT and REQUIREMENT_LIBRARY_NODE table. 
			Data is now in REQUIREMENT_VERSION and REQUIREMENT_FOLDER tables.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.21::fogaillard
--  Add Prerequisite collumn to the test_case table
ALTER TABLE TEST_CASE ADD PREREQUISITE LONGTEXT DEFAULT null NULL COMMENT 'the prerequisite for a test_case';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.21', 'fogaillard', '../tm/tm.changelog-1.1.0.xml', NOW(), 21, '8:03bf284d5de34979ee98fcac237c5185', 'addColumn tableName=TEST_CASE', 'Add Prerequisite collumn to the test_case table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.22::bsiri
--  Add the table TEST_SUITE. A TEST_SUITE is basically a view on a subset of ITERATION_TEST_PLAN_ITEMs.
CREATE TABLE TEST_SUITE (ID BIGINT AUTO_INCREMENT NOT NULL, NAME VARCHAR(100) NULL, `DESCRIPTION` LONGTEXT DEFAULT null NULL, ATTACHMENT_LIST_ID BIGINT NOT NULL, CREATED_BY VARCHAR(50) NOT NULL COMMENT 'Who created this test suite', CREATED_ON datetime NOT NULL COMMENT 'When this test suite was created', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Who modified this test suite last', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'When this test suite was last modified', CONSTRAINT PK_TEST_SUITE PRIMARY KEY (ID), CONSTRAINT fk_test_suite_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.22', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 22, '8:75a63f617964c60504d4b4f74538326b', 'createTable tableName=TEST_SUITE', 'Add the table TEST_SUITE. A TEST_SUITE is basically a view on a subset of ITERATION_TEST_PLAN_ITEMs.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.23::bsiri
--  Association table between ITERATION and TEST_SUITE. Like in many other places here, the purpose of this association table is not to model a n-n cardinality between ITERATION and 
--  			TEST_SUITE, but 1-n. We thus gain performance at the expense of the model quality.
CREATE TABLE ITERATION_TEST_SUITE (ITERATION_ID BIGINT NOT NULL, TEST_SUITE_ID BIGINT NOT NULL, CONSTRAINT fk_iteration_test_suite_suite FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITE(ID), CONSTRAINT fk_iteration_test_suite_iteration FOREIGN KEY (ITERATION_ID) REFERENCES ITERATION(ITERATION_ID), UNIQUE (TEST_SUITE_ID));

CREATE INDEX dx_iteration_test_suite_iteration ON ITERATION_TEST_SUITE(ITERATION_ID);

CREATE INDEX dx_iteration_test_suite_suite ON ITERATION_TEST_SUITE(TEST_SUITE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.23', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 23, '8:63216caca4ea5bc08a3dd61771acfd15', 'createTable tableName=ITERATION_TEST_SUITE; createIndex indexName=dx_iteration_test_suite_iteration, tableName=ITERATION_TEST_SUITE; createIndex indexName=dx_iteration_test_suite_suite, tableName=ITERATION_TEST_SUITE', 'Association table between ITERATION and TEST_SUITE. Like in many other places here, the purpose of this association table is not to model a n-n cardinality between ITERATION and 
			TEST_SUITE, but 1-n. We thus gain performance at the expense of t...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.24::bsiri
--  Hereby an ITERATION_TEST_PLAN_ITEM shalt reference 0 or 1 TEST_SUITE
ALTER TABLE ITERATION_TEST_PLAN_ITEM ADD TEST_SUITE BIGINT DEFAULT null NULL;

ALTER TABLE ITERATION_TEST_PLAN_ITEM ADD CONSTRAINT fk_itpi_testsuite FOREIGN KEY (TEST_SUITE) REFERENCES TEST_SUITE (ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.24', 'bsiri', '../tm/tm.changelog-1.1.0.xml', NOW(), 24, '8:69633e16af59a99ff6f92ca1c17cc960', 'addColumn tableName=ITERATION_TEST_PLAN_ITEM', 'Hereby an ITERATION_TEST_PLAN_ITEM shalt reference 0 or 1 TEST_SUITE', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Changeset ../tm/tm.changelog-1.1.0.xml::tm-1.1.0.25::fogaillard
--  Add Prerequisite collumn to the execution table
ALTER TABLE EXECUTION ADD PREREQUISITE LONGTEXT DEFAULT null NULL COMMENT 'the prerequisite for a test_case execution';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.1.0.25', 'fogaillard', '../tm/tm.changelog-1.1.0.xml', NOW(), 25, '8:64beff4d7a26329a9dc5fb98a5f5a797', 'addColumn tableName=EXECUTION', 'Add Prerequisite collumn to the execution table', 'EXECUTED', NULL, NULL, '4.17.2', '9340183858');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

