--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.11.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0::flaurens
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.11.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0', 'flaurens', '../tm/tm.changelog-1.11.0.xml', NOW(), 1, '8:03a0d2fab9cdab890310d899b02e884f', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3576-1::bsiri
--  Prepares the table CUSTOM_FIELD for possible default_values of type TEXT.
--    		Also accepts now a new value for the column FIELD_TYPE : RTF (for rich text fields) - no structural changes for that though.
ALTER TABLE CUSTOM_FIELD ADD LARGE_DEFAULT_VALUE TEXT DEFAULT null NULL COMMENT 'this column is used by rich text cufs. It contains HTML data.';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3576-1', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 2, '8:046be71c438101fd3b919c2c57f4507e', 'addColumn tableName=CUSTOM_FIELD', 'Prepares the table CUSTOM_FIELD for possible default_values of type TEXT.
  		Also accepts now a new value for the column FIELD_TYPE : RTF (for rich text fields) - no structural changes for that though.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3576-2::bsiri
--  prepares the table CUSTOM_FIELD_VALUE for values of type CLOB, and adds support for inheritance to that end.
ALTER TABLE CUSTOM_FIELD_VALUE ADD LARGE_VALUE TEXT DEFAULT null NULL COMMENT 'this column is used by rich text cufs. It contains HTML data.' , ADD FIELD_TYPE VARCHAR(3) DEFAULT 'CF' NOT NULL COMMENT 'CF : simple, RTF : rich text field';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3576-2', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 3, '8:e8e15c8f5b92d56655543e59bf88c57e', 'addColumn tableName=CUSTOM_FIELD_VALUE', 'prepares the table CUSTOM_FIELD_VALUE for values of type CLOB, and adds support for inheritance to that end.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3576-3::bsiri
--  Prepares the table DENORMALIZED_FIELD_VALUE for values of type CLOB, and adds support for inheritance to that end.
--    		Also accepts now a new value for the column FIELD_TYPE : RTF (for rich text fields) - no structural changes for that though.
ALTER TABLE DENORMALIZED_FIELD_VALUE ADD LARGE_VALUE TEXT DEFAULT null NULL COMMENT 'this column is used by rich text cufs. It contains HTML data.';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3576-3', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 4, '8:275f19eeecd96b3df5a5768f7d75a0c5', 'addColumn tableName=DENORMALIZED_FIELD_VALUE', 'Prepares the table DENORMALIZED_FIELD_VALUE for values of type CLOB, and adds support for inheritance to that end.
  		Also accepts now a new value for the column FIELD_TYPE : RTF (for rich text fields) - no structural changes for that though.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3556-4::kdrifi
--  Cleaning duplicates of column ROLE_USER in table core_group _authority
DELETE FROM CORE_GROUP_AUTHORITY WHERE AUTHORITY='ROLE_USER';

DELETE FROM CORE_GROUP_AUTHORITY WHERE GROUP_ID = 1
        and AUTHORITY='ROLE_TM_USER';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3556-4', 'kdrifi', '../tm/tm.changelog-1.11.0.xml', NOW(), 5, '8:4ef890c9a78f75194ffba62010194127', 'delete tableName=CORE_GROUP_AUTHORITY; delete tableName=CORE_GROUP_AUTHORITY', 'Cleaning duplicates of column ROLE_USER in table core_group _authority', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3577-1::mpagnon
--  Fix columns with CHAR(X) types to VARCHAR(X) type to avoid blank space filling by Postgresql
ALTER TABLE CUSTOM_FIELD MODIFY INPUT_TYPE VARCHAR(30);

ALTER TABLE CUSTOM_FIELD MODIFY FIELD_TYPE VARCHAR(3);

ALTER TABLE DENORMALIZED_FIELD_VALUE MODIFY FIELD_TYPE VARCHAR(3);

ALTER TABLE DENORMALIZED_FIELD_VALUE MODIFY INPUT_TYPE VARCHAR(30);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3577-1', 'mpagnon', '../tm/tm.changelog-1.11.0.xml', NOW(), 6, '8:3f8e023b7e017ef8467ec2b398a0ecb6', 'modifyDataType columnName=INPUT_TYPE, tableName=CUSTOM_FIELD; modifyDataType columnName=FIELD_TYPE, tableName=CUSTOM_FIELD; modifyDataType columnName=FIELD_TYPE, tableName=DENORMALIZED_FIELD_VALUE; modifyDataType columnName=INPUT_TYPE, tableName=D...', 'Fix columns with CHAR(X) types to VARCHAR(X) type to avoid blank space filling by Postgresql', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.9.0.feature-3138-2::jsimon
ALTER TABLE CAMPAIGN_LIBRARY_CONTENT MODIFY CONTENT_ORDER INT NOT NULL;

ALTER TABLE CLN_RELATIONSHIP MODIFY CONTENT_ORDER INT NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.9.0.feature-3138-2', 'jsimon', '../tm/tm.changelog-1.11.0.xml', NOW(), 7, '8:481e650cd1e40f2a7642889911903e39', 'addNotNullConstraint columnName=CONTENT_ORDER, tableName=CAMPAIGN_LIBRARY_CONTENT; addNotNullConstraint columnName=CONTENT_ORDER, tableName=CLN_RELATIONSHIP', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.9.0.feature-3138-4::jsimon
ALTER TABLE RLN_RELATIONSHIP MODIFY CONTENT_ORDER INT NOT NULL;

ALTER TABLE REQUIREMENT_LIBRARY_CONTENT MODIFY CONTENT_ORDER INT NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.9.0.feature-3138-4', 'jsimon', '../tm/tm.changelog-1.11.0.xml', NOW(), 8, '8:9377d668adfd32c2a981d69615b54d04', 'addNotNullConstraint columnName=CONTENT_ORDER, tableName=RLN_RELATIONSHIP; addNotNullConstraint columnName=CONTENT_ORDER, tableName=REQUIREMENT_LIBRARY_CONTENT', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.9.0.feature-3138-6::jsimon
ALTER TABLE TCLN_RELATIONSHIP MODIFY CONTENT_ORDER INT NOT NULL;

ALTER TABLE TEST_CASE_LIBRARY_CONTENT MODIFY CONTENT_ORDER INT NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.9.0.feature-3138-6', 'jsimon', '../tm/tm.changelog-1.11.0.xml', NOW(), 9, '8:1b5f45c17e669616d5ba536cc9452d02', 'addNotNullConstraint columnName=CONTENT_ORDER, tableName=TCLN_RELATIONSHIP; addNotNullConstraint columnName=CONTENT_ORDER, tableName=TEST_CASE_LIBRARY_CONTENT', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3693-1::bsiri
--  Adding support for call-step level management of datasets
ALTER TABLE CALL_TEST_STEP ADD CALLED_DATASET BIGINT DEFAULT null NULL COMMENT 'A reference to the called dataset (if any). The fk constraint must set null when the dataset is deleted.' , ADD DELEGATE_PARAMETER_VALUES BIT(1) DEFAULT 0 NOT NULL COMMENT 'Says whether the parameters of the called test case must be set by the caller test case or not';

ALTER TABLE CALL_TEST_STEP ADD CONSTRAINT fk_call_step_dataset FOREIGN KEY (CALLED_DATASET) REFERENCES DATASET (DATASET_ID) ON DELETE SET NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3693-1', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 10, '8:3d28fc731b1b0df5b42e60edd0a21c6b', 'addColumn tableName=CALL_TEST_STEP; addForeignKeyConstraint baseTableName=CALL_TEST_STEP, constraintName=fk_call_step_dataset, referencedTableName=DATASET', 'Adding support for call-step level management of datasets', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3693-2::bsiri
--  For back compatibility, the call steps migrating from an existing DB will now be set to delegate the parameters
UPDATE CALL_TEST_STEP SET DELEGATE_PARAMETER_VALUES = 1;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3693-2', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 11, '8:dd832c6cfeba03cdd1024f942f566970', 'update tableName=CALL_TEST_STEP', 'For back compatibility, the call steps migrating from an existing DB will now be set to delegate the parameters', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3700-1::bsiri
--  Items of a campaign test plan can now reference Datasets
ALTER TABLE CAMPAIGN_TEST_PLAN_ITEM ADD DATASET_ID BIGINT NULL COMMENT 'the dataset the test plan item should use so that new iterations will now use those datasets';

ALTER TABLE CAMPAIGN_TEST_PLAN_ITEM ADD CONSTRAINT fk_camp_test_plan_item_dataset FOREIGN KEY (DATASET_ID) REFERENCES DATASET (DATASET_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3700-1', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 12, '8:5ff62c57bf0c4707cbf77606d1c0eff0', 'addColumn tableName=CAMPAIGN_TEST_PLAN_ITEM', 'Items of a campaign test plan can now reference Datasets', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Changeset ../tm/tm.changelog-1.11.0.xml::tm-1.11.0.feature-3701-1::bsiri
--  An execution now remembers which dataset was used (or not). That new column encodes three states :
--  				"" -> no dataset used,
--  				somelabel -> the label of the dataset used,
--  				null -> the test case had no parameters anyway
ALTER TABLE EXECUTION ADD DATASET_LABEL VARCHAR(255) NULL COMMENT 'the name of the dataset used';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.11.0.feature-3701-1', 'bsiri', '../tm/tm.changelog-1.11.0.xml', NOW(), 13, '8:81dfe5232f8d4d181dd151c922e82950', 'addColumn tableName=EXECUTION', 'An execution now remembers which dataset was used (or not). That new column encodes three states :
				"" -> no dataset used,
				somelabel -> the label of the dataset used,
				null -> the test case had no parameters anyway', 'EXECUTED', NULL, NULL, '4.17.2', '9340184660');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

