--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.16.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
--  Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340185013');

--  Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0::jprioux
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.16.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 2, '8:ef2d0b4d85aa73343955979430857140', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340185013');

--  Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-feature-6763::jprioux
--  column for last connected on
ALTER TABLE CORE_USER ADD LAST_CONNECTED_ON datetime NULL COMMENT 'a column to persist the last connection date';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-feature-6763', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 3, '8:9177032ded7ea353d8e4f8e87eafe649', 'addColumn tableName=CORE_USER', 'column for last connected on', 'EXECUTED', NULL, NULL, '4.17.2', '9340185013');

--  Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-feature-6799::jlor
CREATE TABLE REQUIREMENT_VERSION_LINK_TYPE (TYPE_ID BIGINT AUTO_INCREMENT NOT NULL, ROLE_1 VARCHAR(50) NULL, ROLE_1_CODE VARCHAR(30) NULL, ROLE_2 VARCHAR(50) NULL, ROLE_2_CODE VARCHAR(30) NULL, IS_DEFAULT BIT(1) DEFAULT 0 NOT NULL COMMENT 'Only one item per list should have it true ', CONSTRAINT PK_REQUIREMENT_VERSION_LINK_TYPE PRIMARY KEY (TYPE_ID));

CREATE TABLE REQUIREMENT_VERSION_LINK (LINK_ID BIGINT AUTO_INCREMENT NOT NULL, LINK_TYPE_ID BIGINT NOT NULL COMMENT 'foreign key to the requirement_version_link_type table', LINK_DIRECTION BIT(1) DEFAULT 0 NOT NULL, REQUIREMENT_VERSION_ID BIGINT NOT NULL COMMENT 'foreign key for requirement version to requirement_version table', RELATED_REQUIREMENT_VERSION_ID BIGINT NOT NULL COMMENT 'foreign key for related requirement version to requirement_version table', CONSTRAINT PK_REQUIREMENT_VERSION_LINK PRIMARY KEY (LINK_ID), CONSTRAINT fk_req_version_link_req_version_link_type_link_type_id FOREIGN KEY (LINK_TYPE_ID) REFERENCES REQUIREMENT_VERSION_LINK_TYPE(TYPE_ID), CONSTRAINT fk_requirement_version_link_related_requirement_version_id FOREIGN KEY (RELATED_REQUIREMENT_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID), CONSTRAINT fk_requirement_version_link_requirement_version_id FOREIGN KEY (REQUIREMENT_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID));

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.related', 'RELATED', 'requirement-version.link.type.related', 'RELATED', 1);

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.parent', 'PARENT', 'requirement-version.link.type.child', 'CHILD', 0);

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.duplicate', 'DUPLICATE', 'requirement-version.link.type.duplicate', 'DUPLICATE', 0);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-feature-6799', 'jlor', '../tm/tm.changelog-1.16.0.xml', NOW(), 4, '8:2c2333c7188e9c02b475b74e2b5408fe', 'createTable tableName=REQUIREMENT_VERSION_LINK_TYPE; createTable tableName=REQUIREMENT_VERSION_LINK; insert tableName=REQUIREMENT_VERSION_LINK_TYPE; insert tableName=REQUIREMENT_VERSION_LINK_TYPE; insert tableName=REQUIREMENT_VERSION_LINK_TYPE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340185013');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

