--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.5.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00::mpagnon
--  Update TM database version number
UPDATE CORE_CONFIG SET STR_KEY = 'squashtest.tm.database.version', VALUE = '1.5.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 1, '8:e21f74e20ec335f77a64538102408c85', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.feat-1596.02::bsiri
--  dropping the temp table from changest tm-1.4.0.feat-1596.01
DROP TABLE EXECUTION_TEST_CASE_DATA;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.feat-1596.02', 'bsiri', '../tm/tm.changelog-1.5.0.xml', NOW(), 2, '8:3ccf3fe5de209e1556bb8d0be7bf2661', 'dropTable tableName=EXECUTION_TEST_CASE_DATA', 'dropping the temp table from changest tm-1.4.0.feat-1596.01', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-issue-1838.01::mpagnon
--  Update table custom-field-value so that all mandatory cuf have a value
update CUSTOM_FIELD_VALUE
			set VALUE = (
			select cf.DEFAULT_VALUE
			from CUSTOM_FIELD_BINDING cfb
			join CUSTOM_FIELD cf on cfb.CF_ID =
			cf.CF_ID
			where cfb.CFB_ID = CUSTOM_FIELD_VALUE.CFB_ID
			)
			where
			(CUSTOM_FIELD_VALUE.VALUE is null or
			LTRIM(RTRIM(CUSTOM_FIELD_VALUE.VALUE)) = '' )
			and exists (
			select *
			from CUSTOM_FIELD_BINDING cfb
			join CUSTOM_FIELD cf on cfb.CF_ID =
			cf.CF_ID
			where cfb.CFB_ID = CUSTOM_FIELD_VALUE.CFB_ID
			and cf.OPTIONAL =
			false);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-issue-1838.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 3, '8:a52132e64716ffdf7220ef3a69d67f7a', 'sql', 'Update table custom-field-value so that all mandatory cuf have a value', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1390.03::bsiri
--  adding cascade delete on the rendering locations when custom field bindings are removed (prune the orphans)
ALTER TABLE CUSTOM_FIELD_RENDERING_LOCATION DROP FOREIGN KEY fk_cfb_render_loc_cfb;

ALTER TABLE CUSTOM_FIELD_RENDERING_LOCATION ADD CONSTRAINT fk_cfb_render_loc_cfb FOREIGN KEY (CFB_ID) REFERENCES CUSTOM_FIELD_BINDING (CFB_ID) ON DELETE CASCADE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1390.03', 'bsiri', '../tm/tm.changelog-1.5.0.xml', NOW(), 4, '8:f3faf7e95d011321140d9e6385ef2cd6', 'dropForeignKeyConstraint baseTableName=CUSTOM_FIELD_RENDERING_LOCATION, constraintName=fk_cfb_render_loc_cfb; addForeignKeyConstraint baseTableName=CUSTOM_FIELD_RENDERING_LOCATION, constraintName=fk_cfb_render_loc_cfb, referencedTableName=CUSTOM_F...', 'adding cascade delete on the rendering locations when custom field bindings are removed (prune the orphans)', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1850.01::mpagnon
--  The table DENORMALIZED_FIELD_VALUE holds instances of a FIELD that are bound to instances of :
--  			executions, execution-steps	when they are created from test-cases or test-case-steps holding CUSTOM_FIELDS.
--  			A "denormalized field value" is destroyed when the "denormalized field holder" instance is destroyed.
--  
--  			Note that in this table the coupling between the "denormalized field value" and the "denormalized field holder" is week : it consists of a pair
--  			of Type/ID (DENORMALIZED_FIELD_HOLDER_TYPE and DENORMALIZED_FIELD_HOLDER_ID) rather than a foreign key to the said entity, nor is true
--  			the opposite ( ie no FK from an execution to a denormalized field value).
CREATE TABLE DENORMALIZED_FIELD_VALUE (DFV_ID BIGINT AUTO_INCREMENT NOT NULL, CFV_ID BIGINT NULL COMMENT 'the custom field value where the denormalized field is copied from', CODE VARCHAR(30) DEFAULT '' NOT NULL, DENORMALIZED_FIELD_HOLDER_ID BIGINT NOT NULL COMMENT 'the id of the denormalized field holder.', DENORMALIZED_FIELD_HOLDER_TYPE VARCHAR(30) NOT NULL COMMENT 'the kind of entity.', INPUT_TYPE CHAR(30) NOT NULL, LABEL VARCHAR(255) DEFAULT '' NOT NULL, POSITION INT NULL, VALUE VARCHAR(255) NULL COMMENT 'the value of that particular custom field value', CONSTRAINT pk_denormalized_field PRIMARY KEY (DFV_ID));

ALTER TABLE DENORMALIZED_FIELD_VALUE ADD CONSTRAINT fk_dfv_cfv_binding FOREIGN KEY (CFV_ID) REFERENCES CUSTOM_FIELD_VALUE (CFV_ID) ON DELETE CASCADE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1850.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 5, '8:db8ccd6b71ac152fd69424e36c783041', 'createTable tableName=DENORMALIZED_FIELD_VALUE; addForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_VALUE, constraintName=fk_dfv_cfv_binding, referencedTableName=CUSTOM_FIELD_VALUE', 'The table DENORMALIZED_FIELD_VALUE holds instances of a FIELD that are bound to instances of :
			executions, execution-steps	when they are created from test-cases or test-case-steps holding CUSTOM_FIELDS.
			A "denormalized field value" is destro...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1850.02::mpagnon
--  Create table for denormalized field rendering location
CREATE TABLE DENORMALIZED_FIELD_RENDERING_LOCATION (DFV_ID BIGINT NOT NULL, RENDERING_LOCATION VARCHAR(30) NOT NULL);

ALTER TABLE DENORMALIZED_FIELD_RENDERING_LOCATION ADD CONSTRAINT fk_dfb_render_loc_dfb FOREIGN KEY (DFV_ID) REFERENCES DENORMALIZED_FIELD_VALUE (DFV_ID) ON DELETE CASCADE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1850.02', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 6, '8:c90694cb598e087cd8be205d61f88578', 'createTable tableName=DENORMALIZED_FIELD_RENDERING_LOCATION; addForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_RENDERING_LOCATION, constraintName=fk_dfb_render_loc_dfb, referencedTableName=DENORMALIZED_FIELD_VALUE', 'Create table for denormalized field rendering location', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0-feat-821::gfouquet
--  Change class names in ACL system
UPDATE ACL_CLASS SET CLASSNAME = 'org.squashtest.tm.domain.project.Project' WHERE CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project';

UPDATE ACL_CLASS SET CLASSNAME = 'org.squashtest.tm.domain.requirement.RequirementLibrary' WHERE CLASSNAME = 'org.squashtest.csp.tm.domain.requirement.RequirementLibrary';

UPDATE ACL_CLASS SET CLASSNAME = 'org.squashtest.tm.domain.testcase.TestCaseLibrary' WHERE CLASSNAME = 'org.squashtest.csp.tm.domain.testcase.TestCaseLibrary';

UPDATE ACL_CLASS SET CLASSNAME = 'org.squashtest.tm.domain.campaign.CampaignLibrary' WHERE CLASSNAME = 'org.squashtest.csp.tm.domain.campaign.CampaignLibrary';

UPDATE ACL_CLASS SET CLASSNAME = 'org.squashtest.tm.domain.project.ProjectTemplate' WHERE CLASSNAME = 'org.squashtest.csp.tm.domain.project.ProjectTemplate';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0-feat-821', 'gfouquet', '../tm/tm.changelog-1.5.0.xml', NOW(), 7, '8:9b0a858bca6a4a9bf0a86c6d6a18b0b1', 'update tableName=ACL_CLASS; update tableName=ACL_CLASS; update tableName=ACL_CLASS; update tableName=ACL_CLASS; update tableName=ACL_CLASS', 'Change class names in ACL system', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.01::mpagnon
--  Create tables CORE_PARTY, CORE_TEAM
CREATE TABLE CORE_PARTY (PARTY_ID BIGINT AUTO_INCREMENT NOT NULL, CONSTRAINT pk_party PRIMARY KEY (PARTY_ID));

CREATE TABLE CORE_TEAM (PARTY_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est aussi une cle etrangere vers la table PARTY_ID Ne doit donc pas etre autogeneree.', NAME VARCHAR(50) NOT NULL, `DESCRIPTION` VARCHAR(255) NULL, CREATED_BY VARCHAR(50) NOT NULL, CREATED_ON datetime NOT NULL COMMENT 'Date de creation. Il s''agit de la date de creation de l''entree dans      la base, non d''une date metier.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', CONSTRAINT pk_team PRIMARY KEY (PARTY_ID), CONSTRAINT fk_team_party FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY(PARTY_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 8, '8:6ac26b6e93872549457b02672218bdd5', 'createTable tableName=CORE_PARTY; createTable tableName=CORE_TEAM', 'Create tables CORE_PARTY, CORE_TEAM', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.02::mpagnon
--  change name of USER_ID into PARTY_ID in CORE_USER, ACL_RESPONSIBILITY_SCOPE_ENTRY and CORE_GROUP_MEMBER. We need to drop FKs on user first.
ALTER TABLE CAMPAIGN_TEST_PLAN_ITEM DROP FOREIGN KEY fk_camp_tp_user;

ALTER TABLE ITERATION_TEST_PLAN_ITEM DROP FOREIGN KEY fk_itertestplan_user;

ALTER TABLE ACL_RESPONSIBILITY_SCOPE_ENTRY DROP FOREIGN KEY FK_RESP_SCOPE_USER;

ALTER TABLE CORE_GROUP_MEMBER DROP FOREIGN KEY FK_GRP_MEMBER_USR;

ALTER TABLE CORE_USER CHANGE ID PARTY_ID BIGINT;

ALTER TABLE ACL_RESPONSIBILITY_SCOPE_ENTRY CHANGE USER_ID PARTY_ID BIGINT;

ALTER TABLE CORE_GROUP_MEMBER CHANGE USER_ID PARTY_ID BIGINT;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.02', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 9, '8:ccee6a16065b0bd3a8b2e9d446979e1d', 'dropForeignKeyConstraint baseTableName=CAMPAIGN_TEST_PLAN_ITEM, constraintName=fk_camp_tp_user; dropForeignKeyConstraint baseTableName=ITERATION_TEST_PLAN_ITEM, constraintName=fk_itertestplan_user; dropForeignKeyConstraint baseTableName=ACL_RESPON...', 'change name of USER_ID into PARTY_ID in CORE_USER, ACL_RESPONSIBILITY_SCOPE_ENTRY and CORE_GROUP_MEMBER. We need to drop FKs on user first.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.04::mpagnon
--  Create a PARTY for each CORE_USER
insert into CORE_PARTY(PARTY_ID)
			select PARTY_ID from CORE_USER;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.04', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 10, '8:a1007915d3c3e3d68a49d416b23c9c48', 'sql', 'Create a PARTY for each CORE_USER', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.05::mpagnon
--  Replace reference on user with reference on party
ALTER TABLE ACL_RESPONSIBILITY_SCOPE_ENTRY ADD CONSTRAINT fk_arse_party FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY (PARTY_ID);

ALTER TABLE CORE_GROUP_MEMBER ADD CONSTRAINT fk_group_member_party FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY (PARTY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.05', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 11, '8:114d2114c5421dc19d25d68de87e989c', 'addForeignKeyConstraint baseTableName=ACL_RESPONSIBILITY_SCOPE_ENTRY, constraintName=fk_arse_party, referencedTableName=CORE_PARTY; addForeignKeyConstraint baseTableName=CORE_GROUP_MEMBER, constraintName=fk_group_member_party, referencedTableName=...', 'Replace reference on user with reference on party', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.06::mpagnon
--  Remove autoIncrement on core_user pk and add fk on Party table
ALTER TABLE CORE_USER DROP PRIMARY KEY;

ALTER TABLE CORE_USER ADD PRIMARY KEY (PARTY_ID);

ALTER TABLE CORE_USER ADD CONSTRAINT fk_core_user_party FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY (PARTY_ID);

ALTER TABLE CAMPAIGN_TEST_PLAN_ITEM ADD CONSTRAINT fk_camp_tp_user FOREIGN KEY (USER_ID) REFERENCES CORE_USER (PARTY_ID);

ALTER TABLE ITERATION_TEST_PLAN_ITEM ADD CONSTRAINT fk_itertestplan_user FOREIGN KEY (USER_ID) REFERENCES CORE_USER (PARTY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.06', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 12, '8:007750c2047ec9e3736fc4d66421407a', 'dropPrimaryKey tableName=CORE_USER; addPrimaryKey constraintName=pk_core_user, tableName=CORE_USER; addForeignKeyConstraint baseTableName=CORE_USER, constraintName=fk_core_user_party, referencedTableName=CORE_PARTY; addForeignKeyConstraint baseTab...', 'Remove autoIncrement on core_user pk and add fk on Party table', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1864.03::mpagnon
--  create table team member
CREATE TABLE CORE_TEAM_MEMBER (TEAM_ID BIGINT NOT NULL, USER_ID BIGINT NOT NULL, CONSTRAINT fk_team_member_team FOREIGN KEY (TEAM_ID) REFERENCES CORE_TEAM(PARTY_ID), CONSTRAINT fk_team_member_user FOREIGN KEY (USER_ID) REFERENCES CORE_USER(PARTY_ID));

CREATE UNIQUE INDEX DX_TEAM_MEMBER ON CORE_TEAM_MEMBER(TEAM_ID, USER_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1864.03', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 13, '8:19e2f95851cfb6a5c61f8f12bd333114', 'createTable tableName=CORE_TEAM_MEMBER; createIndex indexName=DX_TEAM_MEMBER, tableName=CORE_TEAM_MEMBER', 'create table team member', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1984.01::flaurens
--  create table item_test_plan_test_suite
CREATE TABLE TEST_SUITE_TEST_PLAN_ITEM (TPI_ID BIGINT NOT NULL, SUITE_ID BIGINT NOT NULL, CONSTRAINT fk_test_suite_test_plan_item_test_suite FOREIGN KEY (SUITE_ID) REFERENCES TEST_SUITE(ID), CONSTRAINT fk_test_suite_test_plan_item_test_plan_item FOREIGN KEY (TPI_ID) REFERENCES ITERATION_TEST_PLAN_ITEM(ITEM_TEST_PLAN_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1984.01', 'flaurens', '../tm/tm.changelog-1.5.0.xml', NOW(), 14, '8:93c290514f581af3cd51df75bb065da9', 'createTable tableName=TEST_SUITE_TEST_PLAN_ITEM', 'create table item_test_plan_test_suite', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1984.02::flaurens
--  migrate data to table test_suite_test_plan_item
insert into TEST_SUITE_TEST_PLAN_ITEM (TPI_ID, SUITE_ID)
			select ITEM_TEST_PLAN_ID, TEST_SUITE from ITERATION_TEST_PLAN_ITEM
			where TEST_SUITE IS NOT NULL;

ALTER TABLE ITERATION_TEST_PLAN_ITEM DROP FOREIGN KEY fk_itpi_testsuite;

ALTER TABLE ITERATION_TEST_PLAN_ITEM DROP COLUMN TEST_SUITE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1984.02', 'flaurens', '../tm/tm.changelog-1.5.0.xml', NOW(), 15, '8:3ffa83eebe5e3b17e2f783e06c1bc8fe', 'sql; dropForeignKeyConstraint baseTableName=ITERATION_TEST_PLAN_ITEM, constraintName=fk_itpi_testsuite; dropColumn columnName=TEST_SUITE, tableName=ITERATION_TEST_PLAN_ITEM', 'migrate data to table test_suite_test_plan_item', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1902.01::bsiri
--  creating the tables and references for the workspace plugins
CREATE TABLE TEST_CASE_LIBRARY_PLUGINS (LIBRARY_ID BIGINT NOT NULL, PLUGIN_ID VARCHAR(100) NOT NULL, CONSTRAINT fk_plugin_tclib FOREIGN KEY (LIBRARY_ID) REFERENCES TEST_CASE_LIBRARY(TCL_ID));

CREATE TABLE REQUIREMENT_LIBRARY_PLUGINS (LIBRARY_ID BIGINT NOT NULL, PLUGIN_ID VARCHAR(100) NOT NULL, CONSTRAINT fk_plugin_rlib FOREIGN KEY (LIBRARY_ID) REFERENCES REQUIREMENT_LIBRARY(RL_ID));

CREATE TABLE CAMPAIGN_LIBRARY_PLUGINS (LIBRARY_ID BIGINT NOT NULL, PLUGIN_ID VARCHAR(100) NOT NULL, CONSTRAINT fk_plugin_clib FOREIGN KEY (LIBRARY_ID) REFERENCES CAMPAIGN_LIBRARY(CL_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1902.01', 'bsiri', '../tm/tm.changelog-1.5.0.xml', NOW(), 16, '8:cc49ba7569341dba54c4287e4b6ef1ca', 'createTable tableName=TEST_CASE_LIBRARY_PLUGINS; createTable tableName=REQUIREMENT_LIBRARY_PLUGINS; createTable tableName=CAMPAIGN_LIBRARY_PLUGINS', 'creating the tables and references for the workspace plugins', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1984.03::flaurens
--  add column for ordering to table TEST_SUITE_TEST_PLAN_ITEM
ALTER TABLE TEST_SUITE_TEST_PLAN_ITEM ADD TEST_PLAN_ORDER INT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1984.03', 'flaurens', '../tm/tm.changelog-1.5.0.xml', NOW(), 17, '8:12bf0cc7b35d36d35ec5a8def84bb07c', 'addColumn tableName=TEST_SUITE_TEST_PLAN_ITEM', 'add column for ordering to table TEST_SUITE_TEST_PLAN_ITEM', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-2003.01::mpagnon
--  Action Steps now cover Requirements versions. We need to create a new table that will be an enhancement of the TEST_CASE_VERIFIED_REQUIREMENT_VERSION one.
--  We drop the constraint of the old TEST_CASE_VERIFIED_REQUIREMENT_VERSION so that we can create ones with the same names on the new REQUIREMENT_VERSION_COVERAGE table
--  The new table is called  "REQUIREMENT_VERSION_COVERAGE"
ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION DROP FOREIGN KEY fk_verified_req_version;

ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION DROP FOREIGN KEY fk_verifying_test_case;

ALTER TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION DROP KEY uc_tc_verifies_req_version;

CREATE TABLE REQUIREMENT_VERSION_COVERAGE (REQUIREMENT_VERSION_COVERAGE_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'generated surrogate key', VERIFIED_REQ_VERSION_ID BIGINT NULL COMMENT 'FK to the verified requirement version', VERIFYING_TEST_CASE_ID BIGINT NULL COMMENT 'FK to the verifying test case', CONSTRAINT pk_requirement_version_coverage PRIMARY KEY (REQUIREMENT_VERSION_COVERAGE_ID), CONSTRAINT fk_verified_req_version FOREIGN KEY (VERIFIED_REQ_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID), CONSTRAINT fk_verifying_test_case FOREIGN KEY (VERIFYING_TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

ALTER TABLE REQUIREMENT_VERSION_COVERAGE MODIFY VERIFIED_REQ_VERSION_ID BIGINT NOT NULL;

ALTER TABLE REQUIREMENT_VERSION_COVERAGE MODIFY VERIFYING_TEST_CASE_ID BIGINT NOT NULL;

ALTER TABLE REQUIREMENT_VERSION_COVERAGE ADD CONSTRAINT uc_tc_verifies_req_version UNIQUE (VERIFIED_REQ_VERSION_ID, VERIFYING_TEST_CASE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-2003.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 18, '8:f6880055add614f749f7cc30aa109492', 'dropForeignKeyConstraint baseTableName=TEST_CASE_VERIFIED_REQUIREMENT_VERSION, constraintName=fk_verified_req_version; dropForeignKeyConstraint baseTableName=TEST_CASE_VERIFIED_REQUIREMENT_VERSION, constraintName=fk_verifying_test_case; dropUnique...', 'Action Steps now cover Requirements versions. We need to create a new table that will be an enhancement of the TEST_CASE_VERIFIED_REQUIREMENT_VERSION one.
We drop the constraint of the old TEST_CASE_VERIFIED_REQUIREMENT_VERSION so that we can crea...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-2003.02::mpagnon
--  We migrate datas from TEST_CASE_VERIFIED_REQUIREMENT_VERSION to REQUIREMENT_VERSION_COVERAGE.
Insert into REQUIREMENT_VERSION_COVERAGE(VERIFIED_REQ_VERSION_ID, VERIFYING_TEST_CASE_ID)
			select VERIFIED_REQ_VERSION_ID, VERIFYING_TEST_CASE_ID from TEST_CASE_VERIFIED_REQUIREMENT_VERSION;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-2003.02', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 19, '8:c11e14595441a13056edc8f8c4eff9da', 'sql', 'We migrate datas from TEST_CASE_VERIFIED_REQUIREMENT_VERSION to REQUIREMENT_VERSION_COVERAGE.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-2003.03::mpagnon
--  We drop the old TEST_CASE_VERIFIED_REQUIREMENT_VERSION table.
DROP TABLE TEST_CASE_VERIFIED_REQUIREMENT_VERSION;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-2003.03', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 20, '8:ead4924b2d9a1ad541aa904ff47be503', 'dropTable tableName=TEST_CASE_VERIFIED_REQUIREMENT_VERSION', 'We drop the old TEST_CASE_VERIFIED_REQUIREMENT_VERSION table.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-2003.04::mpagnon
--  Let's add a table VERIFYING_STEPS to hold the steps that are concerned by the requirement coverage
CREATE TABLE VERIFYING_STEPS (REQUIREMENT_VERSION_COVERAGE_ID BIGINT NOT NULL COMMENT 'FK to the concerned requirement-version-coverage', TEST_STEP_ID BIGINT NOT NULL COMMENT 'FK to the concerned action test step', CONSTRAINT fk_verifying_step_action_test_step FOREIGN KEY (TEST_STEP_ID) REFERENCES ACTION_TEST_STEP(TEST_STEP_ID), CONSTRAINT fk_verifying_step_requirement_version_coverage FOREIGN KEY (REQUIREMENT_VERSION_COVERAGE_ID) REFERENCES REQUIREMENT_VERSION_COVERAGE(REQUIREMENT_VERSION_COVERAGE_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-2003.04', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 21, '8:d394f967b4143695a514bef61a8e648c', 'createTable tableName=VERIFYING_STEPS', 'Let''s add a table VERIFYING_STEPS to hold the steps that are concerned by the requirement coverage', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-feat-1966.01::bsiri
--  fixing mysql text data type for Squash schema version 1.4.x and before (see issue 1966). Dev note : it would have been best to use
--  		the tag <modifyColumn> instead of raw sql, because the xml could have been efficiently parsed by the dbdoc generator.
--  		However the dbdoc does not tell which datatype the columns anyway (for now), so let us say that the following raw sql is just fine.
ALTER TABLE TEST_CASE_LIBRARY_NODE MODIFY DESCRIPTION longtext;

ALTER TABLE CAMPAIGN_LIBRARY_NODE MODIFY DESCRIPTION longtext;

ALTER TABLE ITERATION MODIFY DESCRIPTION longtext;

ALTER TABLE TEST_SUITE MODIFY DESCRIPTION longtext;

ALTER TABLE PROJECT MODIFY DESCRIPTION longtext;

ALTER TABLE TEST_CASE MODIFY PREREQUISITE longtext;

ALTER TABLE RESOURCE MODIFY DESCRIPTION longtext;

ALTER TABLE REQUIREMENT_LARGE_PROPERTY_CHANGE MODIFY OLD_VALUE longtext;

ALTER TABLE REQUIREMENT_LARGE_PROPERTY_CHANGE MODIFY NEW_VALUE longtext;

ALTER TABLE EXECUTION MODIFY DESCRIPTION longtext;

ALTER TABLE EXECUTION MODIFY PREREQUISITE longtext;

ALTER TABLE EXECUTION_STEP MODIFY ACTION longtext;

ALTER TABLE EXECUTION_STEP MODIFY EXPECTED_RESULT longtext;

ALTER TABLE EXECUTION_STEP MODIFY COMMENT longtext;

ALTER TABLE ACTION_TEST_STEP MODIFY ACTION longtext;

ALTER TABLE ACTION_TEST_STEP MODIFY EXPECTED_RESULT longtext;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-feat-1966.01', 'bsiri', '../tm/tm.changelog-1.5.0.xml', NOW(), 22, '8:767ece40938d9f4eb9d7fa938bdc580a', 'sql', 'fixing mysql text data type for Squash schema version 1.4.x and before (see issue 1966). Dev note : it would have been best to use
		the tag <modifyColumn> instead of raw sql, because the xml could have been efficiently parsed by the dbdoc generat...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-issue-2061.01::mpagnon
--  Because imported test-cases did not have custom-field-values we need to fix the database.
insert into CUSTOM_FIELD_VALUE (BOUND_ENTITY_ID, BOUND_ENTITY_TYPE, CFB_ID, VALUE)
			select tc.TCLN_ID, 'TEST_CASE', binding.CFB_ID, cuf.DEFAULT_VALUE
			from TEST_CASE tc
			join TEST_CASE_LIBRARY_NODE tcln ON tc.TCLN_ID = tcln.TCLN_ID
			join PROJECT project ON tcln.PROJECT_ID = project.PROJECT_ID
			join CUSTOM_FIELD_BINDING binding ON binding.BOUND_PROJECT_ID = project.PROJECT_ID
			join CUSTOM_FIELD cuf ON binding.CF_ID = cuf.CF_ID
			where not exists (
				select * from CUSTOM_FIELD_VALUE val
				where val.BOUND_ENTITY_ID = tc.TCLN_ID
				and val.BOUND_ENTITY_TYPE='TEST_CASE'
				and val.CFB_ID = binding.CFB_ID
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-issue-2061.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 23, '8:23803de2900584e5ecb5fe684ab76954', 'sql', 'Because imported test-cases did not have custom-field-values we need to fix the database.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Changeset ../tm/tm.changelog-1.5.0.xml::tm-1.5.0.00-issue-2146.01::mpagnon
--  This issue is due to null values in database when @NotNull constraint is present in the bean.
--  		This changeSet we will make all java @NotNull be present in database
--  --------------------REQUIREMENT_PROPERTY_CHANGE----------------------------
--  -------------------REQUIREMENT_LARGE_PROPERTY_CHANGE--------------------
--  ----------------------EXECUTION--------------------------
--  -----------------------REQUIREMENT_VERSION-------------------------
--  ----------------------TEST_CASES-----------------------
--  also fix for [Issue 1895]
UPDATE REQUIREMENT_PROPERTY_CHANGE
			SET PROPERTY_NAME = ''
			WHERE PROPERTY_NAME is null;

ALTER TABLE REQUIREMENT_PROPERTY_CHANGE MODIFY PROPERTY_NAME VARCHAR(100) NOT NULL;

UPDATE REQUIREMENT_LARGE_PROPERTY_CHANGE
			SET PROPERTY_NAME = ''
			WHERE PROPERTY_NAME is null;

ALTER TABLE REQUIREMENT_LARGE_PROPERTY_CHANGE MODIFY PROPERTY_NAME VARCHAR(100) NOT NULL;

UPDATE EXECUTION
			SET REFERENCE = ''
			WHERE REFERENCE is null;

ALTER TABLE EXECUTION MODIFY `REFERENCE` VARCHAR(50) NOT NULL;

ALTER TABLE EXECUTION ALTER `REFERENCE` SET DEFAULT '';

UPDATE EXECUTION
			SET PREREQUISITE = ''
			WHERE PREREQUISITE is null;

ALTER TABLE EXECUTION MODIFY PREREQUISITE LONGTEXT NOT NULL;

UPDATE REQUIREMENT_VERSION
			SET REFERENCE = ''
			WHERE REFERENCE is null;

ALTER TABLE REQUIREMENT_VERSION MODIFY `REFERENCE` VARCHAR(50) NOT NULL;

ALTER TABLE REQUIREMENT_VERSION ALTER `REFERENCE` SET DEFAULT '';

UPDATE TEST_CASE
			SET PREREQUISITE= ''
			WHERE PREREQUISITE is null;

ALTER TABLE TEST_CASE MODIFY PREREQUISITE LONGTEXT NOT NULL;

UPDATE TEST_CASE
			SET REFERENCE = ''
			WHERE REFERENCE is null;

ALTER TABLE TEST_CASE MODIFY `REFERENCE` VARCHAR(50) NOT NULL;

ALTER TABLE TEST_CASE ALTER `REFERENCE` SET DEFAULT '';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.5.0.00-issue-2146.01', 'mpagnon', '../tm/tm.changelog-1.5.0.xml', NOW(), 24, '8:480994cb73b1f307f015655b5f5a1f13', 'sql; addNotNullConstraint columnName=PROPERTY_NAME, tableName=REQUIREMENT_PROPERTY_CHANGE; sql; addNotNullConstraint columnName=PROPERTY_NAME, tableName=REQUIREMENT_LARGE_PROPERTY_CHANGE; sql; addNotNullConstraint columnName=REFERENCE, tableName=E...', 'This issue is due to null values in database when @NotNull constraint is present in the bean.
		This changeSet we will make all java @NotNull be present in database
--------------------REQUIREMENT_PROPERTY_CHANGE----------------------------
------...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184175');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

