--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.6.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0::mpagnon
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.6.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0', 'mpagnon', '../tm/tm.changelog-1.6.0.xml', NOW(), 1, '8:84970f7425d89df00712293dba61866a', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2334-01::flaurens
--  Change type of column description in table core_team
CREATE TABLE CORE_TEAM_TEMP (ID BIGINT DEFAULT null NULL, `DESCRIPTION` LONGTEXT DEFAULT null NULL);

insert into CORE_TEAM_TEMP (ID, DESCRIPTION)
			select PARTY_ID, DESCRIPTION from CORE_TEAM;

ALTER TABLE CORE_TEAM DROP COLUMN `DESCRIPTION`;

ALTER TABLE CORE_TEAM ADD `DESCRIPTION` LONGTEXT DEFAULT null NULL;

update CORE_TEAM ct
            set DESCRIPTION = (select ctt.DESCRIPTION
                               from CORE_TEAM_TEMP ctt
                               where ctt.ID = ct.PARTY_ID);

DROP TABLE CORE_TEAM_TEMP;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2334-01', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 2, '8:694074944d1b6e20e367f03d838e7f77', 'createTable tableName=CORE_TEAM_TEMP; sql; dropColumn columnName=DESCRIPTION, tableName=CORE_TEAM; addColumn tableName=CORE_TEAM; sql; dropTable tableName=CORE_TEAM_TEMP', 'Change type of column description in table core_team', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.feat-1101-01::mpagnon
--  Add table to handle test cases PARAMETERS
CREATE TABLE PARAMETER (PARAM_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'the PARAMETER primary key', NAME VARCHAR(255) DEFAULT '' NOT NULL COMMENT 'the parameter name, should be unique among parameters of the same test case', TEST_CASE_ID BIGINT NOT NULL COMMENT 'the test case where the parameter is declared', `DESCRIPTION` LONGTEXT NOT NULL COMMENT 'the description of the parameter', CONSTRAINT pk_parameter PRIMARY KEY (PARAM_ID), CONSTRAINT fk_parameter_test_case FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

ALTER TABLE PARAMETER ADD UNIQUE (NAME, TEST_CASE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.feat-1101-01', 'mpagnon', '../tm/tm.changelog-1.6.0.xml', NOW(), 3, '8:7e472cea2bfbeb95236406d8d5ca915f', 'createTable tableName=PARAMETER; addUniqueConstraint tableName=PARAMETER', 'Add table to handle test cases PARAMETERS', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.feat-1101-02::mpagnon
--  Add tables to handle test cases DATASETS
CREATE TABLE DATASET (DATASET_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'the DATASET primary key', NAME VARCHAR(255) DEFAULT '' NOT NULL COMMENT 'the dataset name, should be unique among parameters of the same test case', TEST_CASE_ID BIGINT NOT NULL COMMENT 'the test case where the parameter is declared', CONSTRAINT pk_dataset PRIMARY KEY (DATASET_ID), CONSTRAINT fk_dataset_test_case FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

ALTER TABLE DATASET ADD UNIQUE (NAME, TEST_CASE_ID);

CREATE TABLE DATASET_PARAM_VALUE (DATASET_PARAM_VALUE_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'the DATASET_PARAM_VALUE primary key', DATASET_ID BIGINT NOT NULL COMMENT 'the dataset holding the value for the parameter', PARAM_ID BIGINT NOT NULL COMMENT 'the parameter to set the value of', PARAM_VALUE VARCHAR(255) DEFAULT '' NOT NULL COMMENT 'the value for the parameter in the dataset', CONSTRAINT pk_dataset_param_value PRIMARY KEY (DATASET_PARAM_VALUE_ID), CONSTRAINT fk_dataset_param_value_dataset FOREIGN KEY (DATASET_ID) REFERENCES DATASET(DATASET_ID), CONSTRAINT fk_dataset_param_value_param FOREIGN KEY (PARAM_ID) REFERENCES PARAMETER(PARAM_ID));

ALTER TABLE DATASET_PARAM_VALUE ADD UNIQUE (DATASET_ID, PARAM_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.feat-1101-02', 'mpagnon', '../tm/tm.changelog-1.6.0.xml', NOW(), 4, '8:2467d49174e0943b8d5906d10c36acb3', 'createTable tableName=DATASET; addUniqueConstraint tableName=DATASET; createTable tableName=DATASET_PARAM_VALUE; addUniqueConstraint tableName=DATASET_PARAM_VALUE', 'Add tables to handle test cases DATASETS', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.feat-1128-01::mpagnon
--  Add column to bind a test plan item to a DATASET
ALTER TABLE ITERATION_TEST_PLAN_ITEM ADD DATASET_ID BIGINT NULL COMMENT 'the dataset the test plan item should use to replace the parameters in new execution steps';

ALTER TABLE ITERATION_TEST_PLAN_ITEM ADD CONSTRAINT fk_iteration_test_plan_item_dataset FOREIGN KEY (DATASET_ID) REFERENCES DATASET (DATASET_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.feat-1128-01', 'mpagnon', '../tm/tm.changelog-1.6.0.xml', NOW(), 5, '8:073426e993c97f1e37629c0d6f6c2ef9', 'addColumn tableName=ITERATION_TEST_PLAN_ITEM', 'Add column to bind a test plan item to a DATASET', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2203-01::flaurens
--  remove inactive users from all teams
delete from CORE_TEAM_MEMBER
			where USER_ID in (select cu.PARTY_ID
			                  from CORE_USER cu
			                  where cu.ACTIVE = false);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2203-01', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 6, '8:58fb190c17063540b58234793162b412', 'sql', 'remove inactive users from all teams', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2203-02::flaurens
--  remove core rights of inactive users
delete from CORE_GROUP_MEMBER
			where PARTY_ID in (select cu.PARTY_ID
			                   from CORE_USER cu
			                   where cu.ACTIVE = false);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2203-02', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 7, '8:794203f439413516472851390612f223', 'sql', 'remove core rights of inactive users', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2203-03::flaurens
--  remove acl rights of inactive users
delete from ACL_RESPONSIBILITY_SCOPE_ENTRY
			where PARTY_ID in (select cu.PARTY_ID
			                   from CORE_USER cu
			                   where cu.ACTIVE = false);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2203-03', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 8, '8:702109314d54d654f8702d9294c0a1ee', 'sql', 'remove acl rights of inactive users', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2454-01::bsiri
--  cleaning test suite test plan ordering : some collections have non-contiguous elements. This
--  		is due to issue #2454, because of shortcomings in the code in charge of deleting test cases and dependent
--  		entities.
--  			It looks pretty much like tm-1.5.0.issue-2261-01 (in the 1.5.1 changelog), except we're not dealing with order = null.
--  
--  			Note : this script might already have been executed if at some point Squash 1.5.2 was used.
-- ------------------------------------------------------------------------------
			-- create the temporary tables
			-- ------------------------------------------------------------------------------

			create table TEMP_DISCONTINUOUS_SUITE_ITEM(ITEM_ID BIGINT NOT NULL, SUITE_ID BIGINT NOT NULL);

create table TEMP_CONTINUOUS_SUITE_ITEM(ITEM_ID BIGINT NOT NULL, SUITE_ID BIGINT NOT NULL, TP_ORDER INT NOT NULL, DUMMY BIGINT NOT NULL);

-- ------------------------------------------------------------------------------
			-- gather the data that need migration
			-- ------------------------------------------------------------------------------

			insert into TEMP_DISCONTINUOUS_SUITE_ITEM (SUITE_ID, ITEM_ID)
			select tstpitem.suite_id, tstpitem.tpi_id
			from TEST_SUITE_TEST_PLAN_ITEM tstpitem
			order by tstpitem.suite_id,  tstpitem.test_plan_order;

-- ------------------------------------------------------------------------------
			-- Code for mysql database to find continuous orders for test suite test plan.
			-- Then we compute continuous orders for test-suite test plan items
			-- ------------------------------------------------------------------------------

			insert into TEMP_CONTINUOUS_SUITE_ITEM ( TP_ORDER, SUITE_ID, ITEM_ID, DUMMY)
			select if(@prevsuite=SUITE_ID,
					  @rownum:=@rownum+1,
				      @rownum:=0)
			TP_ORDER, SUITE_ID, ITEM_ID, (@prevsuite:=SUITE_ID)
			from
			TEMP_DISCONTINUOUS_SUITE_ITEM tdsi, (SELECT @rownum:=0) r, (SELECT @prevsuite:=0) s
			order by SUITE_ID, TP_ORDER;

-- ------------------------------------------------------------------------------
			-- And finally we set the right orders in the concerned table without forgetting to delete the help tables.
			-- ------------------------------------------------------------------------------

			update TEST_SUITE_TEST_PLAN_ITEM
			set TEST_PLAN_ORDER =
				(select TEMP_CONTINUOUS_SUITE_ITEM.TP_ORDER
				from  TEMP_CONTINUOUS_SUITE_ITEM
				where TEMP_CONTINUOUS_SUITE_ITEM.SUITE_ID = TEST_SUITE_TEST_PLAN_ITEM.SUITE_ID
				and TEST_SUITE_TEST_PLAN_ITEM.TPI_ID = TEMP_CONTINUOUS_SUITE_ITEM.ITEM_ID)
			where
				SUITE_ID in (
					select distinct tcsi2.SUITE_ID from TEMP_CONTINUOUS_SUITE_ITEM tcsi2
				);

-- ------------------------------------------------------------------------------
			-- drop the temp tables
			-- ------------------------------------------------------------------------------

			drop table TEMP_DISCONTINUOUS_SUITE_ITEM;

drop table TEMP_CONTINUOUS_SUITE_ITEM;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2454-01', 'bsiri', '../tm/tm.changelog-1.6.0.xml', NOW(), 9, '8:79608767aec1d03030279efb78f23813', 'sql', 'cleaning test suite test plan ordering : some collections have non-contiguous elements. This
		is due to issue #2454, because of shortcomings in the code in charge of deleting test cases and dependent
		entities.
			It looks pretty much like tm-1....', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2454-02::bsiri
--  cleaning test suite test plan ordering : some collections have non-contiguous elements. This
--  		is due to issue #2454, because of shortcomings in the code in charge of deleting test cases and dependent
--  		entities.
--  			It looks pretty much like tm-1.5.0.issue-2261-01 (in the 1.5.1 changelog), except we're not dealing with order = null.
--  
--  			Note : this script might already have been executed if at some point Squash 1.5.2 was used.
--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2454-02-postgresql::mpagnon
--  cleaning test suite test plan ordering : some collections have non-contiguous elements. This
--  		is due to issue #2454, because of shortcomings in the code in charge of deleting test cases and dependent
--  		entities.
--  			It looks pretty much like tm-1.5.0.issue-2261-01 (in the 1.5.1 changelog), except we're not dealing with order = null.
--  
--  			Note : this script might already have been executed if at some point Squash 1.5.2 was used.
--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2474-01::bsiri
--  fixes the action test steps having no custom fields when copied from one project to another. Works for both mysql and h2.
insert into CUSTOM_FIELD_VALUE(bound_entity_id, bound_entity_type, cfb_id, value)
			select ats.test_step_id, 'TEST_STEP',  cfb.cfb_id, cf.default_value
			from ACTION_TEST_STEP ats
			inner join TEST_CASE_STEPS tcs on ats.test_step_id = tcs.step_id
			inner join TEST_CASE_LIBRARY_NODE tcln on tcs.test_case_id = tcln.tcln_id
			inner join CUSTOM_FIELD_BINDING cfb on tcln.project_id = cfb.bound_project_id
			inner join CUSTOM_FIELD cf on cfb.cf_id = cf.cf_id
			where cfb.bound_entity = 'TEST_STEP'
			and ats.test_step_id not in (
				select cfv2.bound_entity_id
				from CUSTOM_FIELD_VALUE cfv2
				inner join CUSTOM_FIELD_BINDING cfb2 on cfv2.cfb_id = cfb2.cfb_id
				where cfb2.bound_entity = 'TEST_STEP'
				and cfb2.bound_project_id = cfb.bound_project_id
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2474-01', 'bsiri', '../tm/tm.changelog-1.6.0.xml', NOW(), 10, '8:09ab8b482d1a03ac958f883056b52a8c', 'sql', 'fixes the action test steps having no custom fields when copied from one project to another. Works for both mysql and h2.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2485-01::flaurens
--  replaces fk-constraint which wrongly cascades the deletion of denormalized field values
ALTER TABLE DENORMALIZED_FIELD_VALUE DROP FOREIGN KEY fk_dfv_cfv_binding;

ALTER TABLE DENORMALIZED_FIELD_VALUE ADD CONSTRAINT fk_dfv_cfv_binding FOREIGN KEY (CFV_ID) REFERENCES CUSTOM_FIELD_VALUE (CFV_ID) ON DELETE SET NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2485-01', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 11, '8:2e2b194d7eb3af45f3c9d92a3eb26c8e', 'dropForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_VALUE, constraintName=fk_dfv_cfv_binding; addForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_VALUE, constraintName=fk_dfv_cfv_binding, referencedTableName=CUSTOM_FIELD_VALUE', 'replaces fk-constraint which wrongly cascades the deletion of denormalized field values', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Changeset ../tm/tm.changelog-1.6.0.xml::tm-1.6.0.issue-2536-01::flaurens
--  giving testrunners reading rights on projects
INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestRunner'), '1', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.tm.domain.project.Project'));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.6.0.issue-2536-01', 'flaurens', '../tm/tm.changelog-1.6.0.xml', NOW(), 12, '8:85bbad401d41bee173273597b6d6809b', 'insert tableName=ACL_GROUP_PERMISSION', 'giving testrunners reading rights on projects', 'EXECUTED', NULL, NULL, '4.17.2', '9340184278');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

