--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.8.2.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2::flaurens
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.8.2' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2', 'flaurens', '../tm/tm.changelog-1.8.2.xml', NOW(), 1, '8:59a000b04124198fe97e3146a18c7a39', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2.feature-3120-01::flaurens
--  Adding denormalized field option table for editable denormalized list valued cufs
CREATE TABLE DENORMALIZED_FIELD_OPTION (DFV_ID BIGINT NOT NULL, LABEL VARCHAR(255) NOT NULL, POSITION INT NOT NULL, CODE VARCHAR(30) NOT NULL, CONSTRAINT fk_df_option_dfv FOREIGN KEY (DFV_ID) REFERENCES DENORMALIZED_FIELD_VALUE(DFV_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2.feature-3120-01', 'flaurens', '../tm/tm.changelog-1.8.2.xml', NOW(), 2, '8:954fdde75f17f05fb0b2b93c03fda108', 'createTable tableName=DENORMALIZED_FIELD_OPTION', 'Adding denormalized field option table for editable denormalized list valued cufs', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2.feature-3120-02::flaurens
--  Old list valued cufs are editable as simple text cufs
UPDATE DENORMALIZED_FIELD_VALUE SET INPUT_TYPE = 'PLAIN_TEXT' WHERE INPUT_TYPE = 'DROPDOWN_LIST';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2.feature-3120-02', 'flaurens', '../tm/tm.changelog-1.8.2.xml', NOW(), 3, '8:02169d341d58170c037f44ad29505421', 'update tableName=DENORMALIZED_FIELD_VALUE', 'Old list valued cufs are editable as simple text cufs', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2.feature-3120-03::flaurens
--  Adding a field type column to denormalized field value table
ALTER TABLE DENORMALIZED_FIELD_VALUE ADD FIELD_TYPE CHAR(3) DEFAULT 'CF' NOT NULL COMMENT 'CF : simple, SSF : multiple-choice';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2.feature-3120-03', 'flaurens', '../tm/tm.changelog-1.8.2.xml', NOW(), 4, '8:2b9cc750f49093e0a2ff6b166276b400', 'addColumn tableName=DENORMALIZED_FIELD_VALUE', 'Adding a field type column to denormalized field value table', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2-feat-3127-01::bsiri
--  As of now X_LIBRARY_PLUGINS are merged in the single table LIBRARY_PLUGIN_BINDING
CREATE TABLE LIBRARY_PLUGIN_BINDING (PLUGIN_BINDING_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'primary key (autogenerated)', LIBRARY_ID BIGINT NULL COMMENT 'ID of the library. It is explicitely nullable because hibernate will first create the row then update this column.', LIBRARY_TYPE CHAR(1) NOT NULL COMMENT 'discriminator of the library. T: test case library, R : requirement library, C : campaign library', PLUGIN_ID VARCHAR(50) NOT NULL COMMENT 'id of the plugin. Note that those plugins aren''t stored in the database and the plugin registry is purely software                (it is basically based on the presence/absence of an OSGI services published by each plugin) so we cannot really enforce referential               integrity. Still, although technically that column cannot be a foreign key, the application uses it as if.', CONSTRAINT PK_LIBRARY_PLUGIN_BINDING PRIMARY KEY (PLUGIN_BINDING_ID));

ALTER TABLE LIBRARY_PLUGIN_BINDING ADD CONSTRAINT uniq_plugin_binding UNIQUE (LIBRARY_ID, LIBRARY_TYPE, PLUGIN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2-feat-3127-01', 'bsiri', '../tm/tm.changelog-1.8.2.xml', NOW(), 5, '8:8baba4afe1f2d7ec386e93a862f5c76a', 'createTable tableName=LIBRARY_PLUGIN_BINDING; addUniqueConstraint constraintName=uniq_plugin_binding, tableName=LIBRARY_PLUGIN_BINDING', 'As of now X_LIBRARY_PLUGINS are merged in the single table LIBRARY_PLUGIN_BINDING', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2-feat-3127-02::bsiri
--  create the table LIBRARY_PLUGIN_PROPERTY
CREATE TABLE LIBRARY_PLUGIN_BINDING_PROPERTY (PLUGIN_BINDING_ID BIGINT NOT NULL COMMENT 'foreign key to LIBRARY_PLUGIN_BINDING', PLUGIN_BINDING_KEY VARCHAR(30) NOT NULL COMMENT 'key of this property', PLUGIN_BINDING_VALUE VARCHAR(255) NOT NULL COMMENT 'value of this property', CONSTRAINT fk_libplugin_property_libplugin FOREIGN KEY (PLUGIN_BINDING_ID) REFERENCES LIBRARY_PLUGIN_BINDING(PLUGIN_BINDING_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2-feat-3127-02', 'bsiri', '../tm/tm.changelog-1.8.2.xml', NOW(), 6, '8:d94b6b9ae66e4f1c3059141d80c3f56d', 'createTable tableName=LIBRARY_PLUGIN_BINDING_PROPERTY', 'create the table LIBRARY_PLUGIN_PROPERTY', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Changeset ../tm/tm.changelog-1.8.2.xml::tm-1.8.2-feat-3127-03::bsiri
--  drop the old tables
DROP TABLE TEST_CASE_LIBRARY_PLUGINS;

DROP TABLE REQUIREMENT_LIBRARY_PLUGINS;

DROP TABLE CAMPAIGN_LIBRARY_PLUGINS;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.2-feat-3127-03', 'bsiri', '../tm/tm.changelog-1.8.2.xml', NOW(), 7, '8:16874602945dba14e36c5a38ea0f6d57', 'dropTable tableName=TEST_CASE_LIBRARY_PLUGINS; dropTable tableName=REQUIREMENT_LIBRARY_PLUGINS; dropTable tableName=CAMPAIGN_LIBRARY_PLUGINS', 'drop the old tables', 'EXECUTED', NULL, NULL, '4.17.2', '9340184501');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

