-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.12.3.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3::bsiri
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.12.3' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 1, '8:dc6d2d6170ded24cc95fc871d154fb67', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187438');

-- Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-1-postgresql::bsiri
-- Fixing data in TCLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from TCLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id, depth
			having count(*) > 1;

delete
			from TCLN_RELATIONSHIP_CLOSURE clos
			using CLOSURECOPY cop
			where cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth;

insert into TCLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-1-postgresql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 2, '8:379f13feccf216cbce7e7481b0743f09', 'sql', 'Fixing data in TCLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340187438');

-- Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-2-postgresql::bsiri
-- Fixing data in RLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from RLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id, depth
			having count(*) > 1;

delete
			from RLN_RELATIONSHIP_CLOSURE clos
			using CLOSURECOPY cop
			where cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth;

insert into RLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-2-postgresql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 3, '8:7ae84a6c944b5e5a6fbb6936daf931e4', 'sql', 'Fixing data in RLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340187438');

-- Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-3-postgresql::bsiri
-- Fixing data in CLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from CLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id, depth
			having count(*) > 1;

delete
			from CLN_RELATIONSHIP_CLOSURE clos
			using CLOSURECOPY cop
			where cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth;

insert into CLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-3-postgresql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 4, '8:3669b25167ee5a9ea22950ff6d0c723c', 'sql', 'Fixing data in CLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340187438');

-- Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-2-1::bsiri
-- now we can add the unique constraints on the closure tables
ALTER TABLE TCLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_tcln_clos UNIQUE (ancestor_id, descendant_id);

ALTER TABLE RLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_rln_clos UNIQUE (ancestor_id, descendant_id);

ALTER TABLE CLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_cln_clos UNIQUE (ancestor_id, descendant_id);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-2-1', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 5, '8:6df9afbc155d2a2f2a8eeaa99293695a', 'addUniqueConstraint constraintName=uniq_tcln_clos, tableName=TCLN_RELATIONSHIP_CLOSURE; addUniqueConstraint constraintName=uniq_rln_clos, tableName=RLN_RELATIONSHIP_CLOSURE; addUniqueConstraint constraintName=uniq_cln_clos, tableName=CLN_RELATIONS...', 'now we can add the unique constraints on the closure tables', 'EXECUTED', NULL, NULL, '4.17.2', '9340187438');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

