-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.13.3.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3::bsiri
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.13.3' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 1, '8:583d37bd7df8df56d447daace1221115', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3-feature-5265-1::bsiri
-- making the capacity of plugin configuration items larger
ALTER TABLE LIBRARY_PLUGIN_BINDING_PROPERTY ALTER COLUMN PLUGIN_BINDING_VALUE TYPE TEXT USING (PLUGIN_BINDING_VALUE::TEXT);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3-feature-5265-1', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 2, '8:ad3d502b277a0e8dda58acdbe2fdd508', 'modifyDataType columnName=PLUGIN_BINDING_VALUE, tableName=LIBRARY_PLUGIN_BINDING_PROPERTY', 'making the capacity of plugin configuration items larger', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3-feature-5265-2::bsiri
-- reworking table REQUIREMENT_SYNC_EXTENDER
ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD REMOTE_FILTER_NAME VARCHAR(150) NOT NULL;

COMMENT ON COLUMN REQUIREMENT_SYNC_EXTENDER.REMOTE_FILTER_NAME IS 'name of a filter (not its ID)';

ALTER TABLE REQUIREMENT_SYNC_EXTENDER DROP CONSTRAINT fk_sync_extender_bugtracker;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER RENAME COLUMN BUGTRACKER_ID TO SERVER_ID;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD CONSTRAINT fk_sync_extender_server FOREIGN KEY (SERVER_ID) REFERENCES BUGTRACKER (BUGTRACKER_ID) ON DELETE CASCADE;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER DROP CONSTRAINT fk_sync_extender_requirement;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD CONSTRAINT fk_sync_extender_requirement FOREIGN KEY (REQUIREMENT_ID) REFERENCES REQUIREMENT (RLN_ID) ON DELETE CASCADE;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3-feature-5265-2', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 3, '8:35006cedc4c73243a67d4c2cf2f40f24', 'addColumn tableName=REQUIREMENT_SYNC_EXTENDER; dropForeignKeyConstraint baseTableName=REQUIREMENT_SYNC_EXTENDER, constraintName=fk_sync_extender_bugtracker; renameColumn newColumnName=SERVER_ID, oldColumnName=BUGTRACKER_ID, tableName=REQUIREMENT_S...', 'reworking table REQUIREMENT_SYNC_EXTENDER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3-feature-5265-3::bsiri
-- adding useful indexes
CREATE INDEX idx_sync_remote_req_id ON REQUIREMENT_SYNC_EXTENDER(REMOTE_REQ_ID);

CREATE INDEX idx_sync_remote_projfilter ON REQUIREMENT_SYNC_EXTENDER(REMOTE_PROJECT_ID, REMOTE_FILTER_NAME);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3-feature-5265-3', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 4, '8:fe6f4a07b70b8d871d45343bc60e2ba1', 'createIndex indexName=idx_sync_remote_req_id, tableName=REQUIREMENT_SYNC_EXTENDER; createIndex indexName=idx_sync_remote_projfilter, tableName=REQUIREMENT_SYNC_EXTENDER', 'adding useful indexes', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3-feature-5265-4::bsiri
-- This view maps a requirement library node to its main resource. Some would say 
-- 			it is redundant with what can be found in tables REQUIREMENT or REQUIREMENT_FOLDER
-- 			but seriously it makes simple things likes getting the name of a generic 
-- 			REQUIREMENT_LIBRARY_NODE much simpler.
CREATE VIEW RLN_RESOURCE AS select fold.rln_id as rln_id, fold.res_id as res_id
			from REQUIREMENT_FOLDER fold 
			UNION
			select req.rln_id as rln_id, req.current_version_id as res_id
			from REQUIREMENT req;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3-feature-5265-4', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 5, '8:2e16043bb6f1dd0782f3b9e2ef3df413', 'createView viewName=RLN_RESOURCE', 'This view maps a requirement library node to its main resource. Some would say 
			it is redundant with what can be found in tables REQUIREMENT or REQUIREMENT_FOLDER
			but seriously it makes simple things likes getting the name of a generic 
			R...', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Changeset ../tm/tm.changelog-1.13.3.xml::tm-1.13.3-feature-5265-5::bsiri
-- new requirement audit trail tables for synchronization events
CREATE TABLE SYNC_REQUIREMENT_CREATION (EVENT_ID BIGINT NOT NULL, SOURCE VARCHAR(255) NOT NULL, CONSTRAINT PK_SYNC_CREATE PRIMARY KEY (EVENT_ID), CONSTRAINT fk_sync_create_audit FOREIGN KEY (EVENT_ID) REFERENCES REQUIREMENT_AUDIT_EVENT(EVENT_ID));

COMMENT ON COLUMN SYNC_REQUIREMENT_CREATION.EVENT_ID IS 'primary key, which is also a foreign key to REQUIREMENT_AUDIT_EVENT (they share that key : do not make this table autoincrement it).';

COMMENT ON COLUMN SYNC_REQUIREMENT_CREATION.SOURCE IS 'the url of the synchronized requirement at the time of creation';

CREATE TABLE SYNC_REQUIREMENT_UPDATE (EVENT_ID BIGINT NOT NULL, SOURCE VARCHAR(255) NOT NULL, CONSTRAINT PK_SYNC_UPDATE PRIMARY KEY (EVENT_ID), CONSTRAINT fk_sync_update_audit FOREIGN KEY (EVENT_ID) REFERENCES REQUIREMENT_AUDIT_EVENT(EVENT_ID));

COMMENT ON COLUMN SYNC_REQUIREMENT_UPDATE.EVENT_ID IS 'primary key, which is also a foreign key to REQUIREMENT_AUDIT_EVENT (they share that key : do not make this table autoincrement it).';

COMMENT ON COLUMN SYNC_REQUIREMENT_UPDATE.SOURCE IS 'the url of the synchronized requirement at the time of update';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.13.3-feature-5265-5', 'bsiri', '../tm/tm.changelog-1.13.3.xml', NOW(), 6, '8:1a73b17e530c2ca172ada8511878181a', 'createTable tableName=SYNC_REQUIREMENT_CREATION; createTable tableName=SYNC_REQUIREMENT_UPDATE', 'new requirement audit trail tables for synchronization events', 'EXECUTED', NULL, NULL, '4.17.2', '9340187557');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

