-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.14.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.14.0.xml::tm-1.14.0::bsiri
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.14.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.0', 'bsiri', '../tm/tm.changelog-1.14.0.xml', NOW(), 1, '8:b8a4cc8d0b66bdc42ac118684ecde133', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187608');

-- Changeset ../tm/tm.changelog-1.14.0.xml::tm-1.14.0-feature-5416::jthebault
CREATE TABLE PARTY_PREFERENCE (PREFERENCE_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, PARTY_ID BIGINT NOT NULL, PREFERENCE_KEY VARCHAR(50), PREFERENCE_VALUE VARCHAR(5000), CONSTRAINT "PARTY_PREFERENCE_pkey" PRIMARY KEY (PREFERENCE_ID), CONSTRAINT fk_party_preference_core_party_party_id FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY(PARTY_ID));

COMMENT ON COLUMN PARTY_PREFERENCE.PARTY_ID IS 'foreign key to the core_party table';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.0-feature-5416', 'jthebault', '../tm/tm.changelog-1.14.0.xml', NOW(), 2, '8:fdc67ca09020a062cad0e5cde3c582c2', 'createTable tableName=PARTY_PREFERENCE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187608');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

