-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.16.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187693');

-- Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0::jprioux
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.16.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 2, '8:ef2d0b4d85aa73343955979430857140', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187693');

-- Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-feature-6763::jprioux
-- column for last connected on
ALTER TABLE CORE_USER ADD LAST_CONNECTED_ON TIMESTAMP WITHOUT TIME ZONE;

COMMENT ON COLUMN CORE_USER.LAST_CONNECTED_ON IS 'a column to persist the last connection date';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-feature-6763', 'jprioux', '../tm/tm.changelog-1.16.0.xml', NOW(), 3, '8:9177032ded7ea353d8e4f8e87eafe649', 'addColumn tableName=CORE_USER', 'column for last connected on', 'EXECUTED', NULL, NULL, '4.17.2', '9340187693');

-- Changeset ../tm/tm.changelog-1.16.0.xml::tm-1.16.0-feature-6799::jlor
CREATE TABLE REQUIREMENT_VERSION_LINK_TYPE (TYPE_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, ROLE_1 VARCHAR(50), ROLE_1_CODE VARCHAR(30), ROLE_2 VARCHAR(50), ROLE_2_CODE VARCHAR(30), IS_DEFAULT BOOLEAN DEFAULT FALSE NOT NULL, CONSTRAINT "REQUIREMENT_VERSION_LINK_TYPE_pkey" PRIMARY KEY (TYPE_ID));

COMMENT ON COLUMN REQUIREMENT_VERSION_LINK_TYPE.IS_DEFAULT IS 'Only one item per list should have it true';

CREATE TABLE REQUIREMENT_VERSION_LINK (LINK_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, LINK_TYPE_ID BIGINT NOT NULL, LINK_DIRECTION BOOLEAN DEFAULT FALSE NOT NULL, REQUIREMENT_VERSION_ID BIGINT NOT NULL, RELATED_REQUIREMENT_VERSION_ID BIGINT NOT NULL, CONSTRAINT "REQUIREMENT_VERSION_LINK_pkey" PRIMARY KEY (LINK_ID), CONSTRAINT fk_req_version_link_req_version_link_type_link_type_id FOREIGN KEY (LINK_TYPE_ID) REFERENCES REQUIREMENT_VERSION_LINK_TYPE(TYPE_ID), CONSTRAINT fk_requirement_version_link_related_requirement_version_id FOREIGN KEY (RELATED_REQUIREMENT_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID), CONSTRAINT fk_requirement_version_link_requirement_version_id FOREIGN KEY (REQUIREMENT_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID));

COMMENT ON COLUMN REQUIREMENT_VERSION_LINK.LINK_TYPE_ID IS 'foreign key to the requirement_version_link_type table';

COMMENT ON COLUMN REQUIREMENT_VERSION_LINK.REQUIREMENT_VERSION_ID IS 'foreign key for requirement version to requirement_version table';

COMMENT ON COLUMN REQUIREMENT_VERSION_LINK.RELATED_REQUIREMENT_VERSION_ID IS 'foreign key for related requirement version to requirement_version table';

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.related', 'RELATED', 'requirement-version.link.type.related', 'RELATED', TRUE);

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.parent', 'PARENT', 'requirement-version.link.type.child', 'CHILD', FALSE);

INSERT INTO REQUIREMENT_VERSION_LINK_TYPE (ROLE_1, ROLE_1_CODE, ROLE_2, ROLE_2_CODE, IS_DEFAULT) VALUES ('requirement-version.link.type.duplicate', 'DUPLICATE', 'requirement-version.link.type.duplicate', 'DUPLICATE', FALSE);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.16.0-feature-6799', 'jlor', '../tm/tm.changelog-1.16.0.xml', NOW(), 4, '8:2c2333c7188e9c02b475b74e2b5408fe', 'createTable tableName=REQUIREMENT_VERSION_LINK_TYPE; createTable tableName=REQUIREMENT_VERSION_LINK; insert tableName=REQUIREMENT_VERSION_LINK_TYPE; insert tableName=REQUIREMENT_VERSION_LINK_TYPE; insert tableName=REQUIREMENT_VERSION_LINK_TYPE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187693');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

