-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.18.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.18.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0::jthebault
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.18.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0', 'jthebault', '../tm/tm.changelog-1.18.0.xml', NOW(), 2, '8:c007b82557a1da7abdfc8a0a8dd981ef', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-connection-log-table::aguilhem
-- Create Connection Attempt Log Table
CREATE TABLE CONNECTION_ATTEMPT_LOG (ATTEMPT_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, LOGIN VARCHAR(50), CONNECTION_DATE TIMESTAMP WITHOUT TIME ZONE NOT NULL, SUCCESS BOOLEAN NOT NULL, CONSTRAINT "CONNECTION_ATTEMPT_LOG_pkey" PRIMARY KEY (ATTEMPT_ID));

COMMENT ON COLUMN CONNECTION_ATTEMPT_LOG.ATTEMPT_ID IS 'autogenerated ID';

COMMENT ON COLUMN CONNECTION_ATTEMPT_LOG.LOGIN IS 'login used to connect';

COMMENT ON COLUMN CONNECTION_ATTEMPT_LOG.CONNECTION_DATE IS 'Date of connection';

COMMENT ON COLUMN CONNECTION_ATTEMPT_LOG.SUCCESS IS 'if connection succeeded or not';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-connection-log-table', 'aguilhem', '../tm/tm.changelog-1.18.0.xml', NOW(), 3, '8:0fc79047ba04c43e0002af165e25172d', 'createTable tableName=CONNECTION_ATTEMPT_LOG', 'Create Connection Attempt Log Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-project-template-link::jlor
-- Adding a column to keep the link between a Project and a Project Template
ALTER TABLE PROJECT ADD TEMPLATE_ID BIGINT;

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_template_id FOREIGN KEY (TEMPLATE_ID) REFERENCES PROJECT (PROJECT_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-project-template-link', 'jlor', '../tm/tm.changelog-1.18.0.xml', NOW(), 4, '8:e24e3c9048470677dbd774874095f7c1', 'addColumn tableName=PROJECT', 'Adding a column to keep the link between a Project and a Project Template', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-feature-7183.1-postgresql::jprioux
-- postgresql - add unique constraint for ordered list : test case steps
drop table if exists TEST_CASE_STEPS_TMP;

create table TEST_CASE_STEPS_TMP AS
                    (select TEST_CASE_ID, STEP_ID, min(STEP_ORDER) STEP_ORDER
                       from TEST_CASE_STEPS
                   group by TEST_CASE_ID, STEP_ID);

create index idx1 on TEST_CASE_STEPS_TMP(TEST_CASE_ID,STEP_ID);

update TEST_CASE_STEPS_TMP t1
           set STEP_ORDER = t2.ligne - 1
          from (select TEST_CASE_ID, STEP_ID, (select count(*)
                                                 from TEST_CASE_STEPS_TMP b
                                                where a.TEST_CASE_ID = b.TEST_CASE_ID
                                                  and a.STEP_ORDER >= b.STEP_ORDER) ligne
                  from TEST_CASE_STEPS_TMP a) t2
         where t1.TEST_CASE_ID = t2.TEST_CASE_ID and t1.STEP_ID = t2.STEP_ID;

truncate table TEST_CASE_STEPS;

insert into TEST_CASE_STEPS
        select a.TEST_CASE_ID, a.STEP_ID,
               a.STEP_ORDER + 1 - (select count(*) from TEST_CASE_STEPS_TMP b
                                where a.TEST_CASE_ID = b.TEST_CASE_ID
                                  and a.STEP_ORDER = b.STEP_ORDER
                                  and a.STEP_ID <= b.STEP_ID
                             group by b.TEST_CASE_ID, b.STEP_ORDER) STEP_ORDER
          from TEST_CASE_STEPS_TMP a;

drop table TEST_CASE_STEPS_TMP;

ALTER TABLE TEST_CASE_STEPS ADD CONSTRAINT uc_test_case_steps_order UNIQUE (TEST_CASE_ID, STEP_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-feature-7183.1-postgresql', 'jprioux', '../tm/tm.changelog-1.18.0.xml', NOW(), 5, '8:e99b41602a69e20245aca4c2da66caa8', 'sql; addUniqueConstraint constraintName=uc_test_case_steps_order, tableName=TEST_CASE_STEPS', 'postgresql - add unique constraint for ordered list : test case steps', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-feature-7183.2-postgresql::jprioux
-- postgresql - add unique constraint for ordered list : tcs in iteration
drop table if exists ITEM_TEST_PLAN_LIST_TMP;

create table ITEM_TEST_PLAN_LIST_TMP AS
                    (select ITERATION_ID, ITEM_TEST_PLAN_ID, min(ITEM_TEST_PLAN_ORDER) ITEM_TEST_PLAN_ORDER
                       from ITEM_TEST_PLAN_LIST
                   group by ITERATION_ID, ITEM_TEST_PLAN_ID);

create index idx2 on ITEM_TEST_PLAN_LIST_TMP(ITERATION_ID, ITEM_TEST_PLAN_ID);

update ITEM_TEST_PLAN_LIST_TMP t1
        set ITEM_TEST_PLAN_ORDER = t2.ligne - 1
        from (select ITERATION_ID, ITEM_TEST_PLAN_ID, (select count(*)
                                     from ITEM_TEST_PLAN_LIST_TMP b
                                    where a.ITERATION_ID = b.ITERATION_ID
                                      and a.ITEM_TEST_PLAN_ORDER >= b.ITEM_TEST_PLAN_ORDER) ligne
                 from ITEM_TEST_PLAN_LIST_TMP a) t2
         where t1.ITERATION_ID = t2.ITERATION_ID and t1.ITEM_TEST_PLAN_ID = t2.ITEM_TEST_PLAN_ID;

truncate table ITEM_TEST_PLAN_LIST;

insert into ITEM_TEST_PLAN_LIST
        select a.ITERATION_ID, a.ITEM_TEST_PLAN_ID,
               a.ITEM_TEST_PLAN_ORDER + 1 - (select count(*) from ITEM_TEST_PLAN_LIST_TMP b
                                where a.ITERATION_ID = b.ITERATION_ID
                                  and a.ITEM_TEST_PLAN_ORDER = b.ITEM_TEST_PLAN_ORDER
                                  and a.ITEM_TEST_PLAN_ID <= b.ITEM_TEST_PLAN_ID
                             group by b.ITERATION_ID, b.ITEM_TEST_PLAN_ORDER) ITEM_TEST_PLAN_ORDER
          from ITEM_TEST_PLAN_LIST_TMP a;

drop table ITEM_TEST_PLAN_LIST_TMP;

ALTER TABLE ITEM_TEST_PLAN_LIST ADD CONSTRAINT uc_item_test_plan_list_order UNIQUE (ITERATION_ID, ITEM_TEST_PLAN_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-feature-7183.2-postgresql', 'jprioux', '../tm/tm.changelog-1.18.0.xml', NOW(), 6, '8:e72977174355023d0420ea6a7dfbc3ef', 'sql; addUniqueConstraint constraintName=uc_item_test_plan_list_order, tableName=ITEM_TEST_PLAN_LIST', 'postgresql - add unique constraint for ordered list : tcs in iteration', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-feature-7183.3-postgresql::jprioux
-- postgresql - add unique constraint for ordered list : tcs in test suite
drop table if exists TEST_SUITE_TEST_PLAN_ITEM_TMP;

create table TEST_SUITE_TEST_PLAN_ITEM_TMP AS
                    (select SUITE_ID, TPI_ID, min(TEST_PLAN_ORDER) TEST_PLAN_ORDER
                       from TEST_SUITE_TEST_PLAN_ITEM
                   group by SUITE_ID, TPI_ID);

create index idx2 on TEST_SUITE_TEST_PLAN_ITEM_TMP(SUITE_ID, TPI_ID);

update TEST_SUITE_TEST_PLAN_ITEM_TMP t1
        set TEST_PLAN_ORDER = t2.ligne - 1
        from (select SUITE_ID, TPI_ID, (select count(*)
                                     from TEST_SUITE_TEST_PLAN_ITEM_TMP b
                                    where a.SUITE_ID = b.SUITE_ID
                                      and a.TEST_PLAN_ORDER >= b.TEST_PLAN_ORDER) ligne
                 from TEST_SUITE_TEST_PLAN_ITEM_TMP a) t2
         where t1.SUITE_ID = t2.SUITE_ID and t1.TPI_ID = t2.TPI_ID;

truncate table TEST_SUITE_TEST_PLAN_ITEM;

insert into TEST_SUITE_TEST_PLAN_ITEM
        select a.TPI_ID, a.SUITE_ID,
               a.TEST_PLAN_ORDER + 1 - (select count(*) from TEST_SUITE_TEST_PLAN_ITEM_TMP b
                                where a.SUITE_ID = b.SUITE_ID
                                  and a.TEST_PLAN_ORDER = b.TEST_PLAN_ORDER
                                  and a.TPI_ID <= b.TPI_ID
                             group by b.SUITE_ID, b.TEST_PLAN_ORDER) TEST_PLAN_ORDER
          from TEST_SUITE_TEST_PLAN_ITEM_TMP a;

drop table TEST_SUITE_TEST_PLAN_ITEM_TMP;

ALTER TABLE TEST_SUITE_TEST_PLAN_ITEM ADD CONSTRAINT uc_test_suite_test_plan_item_order UNIQUE (SUITE_ID, TEST_PLAN_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-feature-7183.3-postgresql', 'jprioux', '../tm/tm.changelog-1.18.0.xml', NOW(), 7, '8:47827527fe0290a952c839e4cf7813f6', 'sql; addUniqueConstraint constraintName=uc_test_suite_test_plan_item_order, tableName=TEST_SUITE_TEST_PLAN_ITEM', 'postgresql - add unique constraint for ordered list : tcs in test suite', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-feature-7183.4-postgresql::jprioux
-- postgresql - add unique constraint for ordered list : tcs in campaign
drop table if exists CAMPAIGN_TEST_PLAN_ITEM_TMP;

create table CAMPAIGN_TEST_PLAN_ITEM_TMP AS
                    (select CTPI_ID, CAMPAIGN_ID, TEST_CASE_ID, USER_ID, min(TEST_PLAN_ORDER) TEST_PLAN_ORDER, DATASET_ID
                       from CAMPAIGN_TEST_PLAN_ITEM
                   group by CAMPAIGN_ID, CTPI_ID);

create index idx2 on CAMPAIGN_TEST_PLAN_ITEM_TMP(CAMPAIGN_ID, CTPI_ID);

update CAMPAIGN_TEST_PLAN_ITEM_TMP t1
           set TEST_PLAN_ORDER = t2.ligne - 1
          from (select CTPI_ID, CAMPAIGN_ID, TEST_CASE_ID, USER_ID, (select count(*)
                                     from CAMPAIGN_TEST_PLAN_ITEM_TMP b
                                    where a.CAMPAIGN_ID = b.CAMPAIGN_ID
                                      and a.TEST_PLAN_ORDER >= b.TEST_PLAN_ORDER) ligne, DATASET_ID
                 from CAMPAIGN_TEST_PLAN_ITEM_TMP a) t2
         where t1.CAMPAIGN_ID = t2.CAMPAIGN_ID and t1.CTPI_ID = t2.CTPI_ID;

truncate table CAMPAIGN_TEST_PLAN_ITEM;

insert into CAMPAIGN_TEST_PLAN_ITEM
        select a.CTPI_ID, a.CAMPAIGN_ID, a.TEST_CASE_ID, a.USER_ID,
               a.TEST_PLAN_ORDER + 1 - (select count(*) from CAMPAIGN_TEST_PLAN_ITEM_TMP b
                                where a.CAMPAIGN_ID = b.CAMPAIGN_ID
                                  and a.TEST_PLAN_ORDER = b.TEST_PLAN_ORDER
                                  and a.CTPI_ID <= b.CTPI_ID
                             group by b.CAMPAIGN_ID, b.TEST_PLAN_ORDER) TEST_PLAN_ORDER, a.DATASET_ID
          from CAMPAIGN_TEST_PLAN_ITEM_TMP a;

drop table CAMPAIGN_TEST_PLAN_ITEM_TMP;

ALTER TABLE CAMPAIGN_TEST_PLAN_ITEM ADD CONSTRAINT uc_campaign_test_plan_item_order UNIQUE (CAMPAIGN_ID, TEST_PLAN_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-feature-7183.4-postgresql', 'jprioux', '../tm/tm.changelog-1.18.0.xml', NOW(), 8, '8:054f8a516b3fbe26362cd856870e3042', 'sql; addUniqueConstraint constraintName=uc_campaign_test_plan_item_order, tableName=CAMPAIGN_TEST_PLAN_ITEM', 'postgresql - add unique constraint for ordered list : tcs in campaign', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-binding-report-to-dashboard::zyang
CREATE TABLE CUSTOM_REPORT_REPORT_BINDING (CRRB_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, CRD_ID BIGINT NOT NULL, REPORT_ID BIGINT NOT NULL, ROW INTEGER, COL INTEGER, SIZE_X INTEGER, SIZE_Y INTEGER, CONSTRAINT PK_CRRB_ID PRIMARY KEY (CRRB_ID), CONSTRAINT fk_chart_bindind_report_definition_report_id FOREIGN KEY (REPORT_ID) REFERENCES REPORT_DEFINITION(REPORT_ID), CONSTRAINT fk_report_bindind_custom_report_dashboard_crd_id FOREIGN KEY (CRD_ID) REFERENCES CUSTOM_REPORT_DASHBOARD(CRD_ID));

COMMENT ON COLUMN CUSTOM_REPORT_REPORT_BINDING.CRRB_ID IS 'pk genere';

COMMENT ON COLUMN CUSTOM_REPORT_REPORT_BINDING.CRD_ID IS 'cle etrangere vers le dashboard.';

COMMENT ON COLUMN CUSTOM_REPORT_REPORT_BINDING.REPORT_ID IS 'cle etrangere vers le report.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-binding-report-to-dashboard', 'zyang', '../tm/tm.changelog-1.18.0.xml', NOW(), 9, '8:3d397a73a7554ac2dec23e806278fc3f', 'createTable tableName=CUSTOM_REPORT_REPORT_BINDING', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-scripted-test-case::jthebault
-- Create the scripted test case table
-- Create the scripted execution table
CREATE TABLE SCRIPTED_TC_EXTENDER (SCRIPTED_TC_EXTENDER_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, SCRIPT TEXT, LANGUAGE VARCHAR(50), TEST_CASE_ID BIGINT NOT NULL, CONSTRAINT "SCRIPTED_TC_EXTENDER_pkey" PRIMARY KEY (SCRIPTED_TC_EXTENDER_ID), CONSTRAINT fk_scripted_extender_test_case FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

COMMENT ON COLUMN SCRIPTED_TC_EXTENDER.SCRIPTED_TC_EXTENDER_ID IS 'autogenerated ID';

COMMENT ON COLUMN SCRIPTED_TC_EXTENDER.SCRIPT IS 'the test case script';

COMMENT ON COLUMN SCRIPTED_TC_EXTENDER.LANGUAGE IS 'scriptLanguage of script';

COMMENT ON COLUMN SCRIPTED_TC_EXTENDER.TEST_CASE_ID IS 'foreign key to TEST_CASE';

CREATE INDEX scripted_tc_extender_test_case_id_idx ON SCRIPTED_TC_EXTENDER(TEST_CASE_ID);

CREATE TABLE SCRIPTED_EXECUTION_EXTENDER (SCRIPTED_EXECUTION_EXTENDER_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, LANGUAGE VARCHAR(50), SCRIPT_NAME VARCHAR(255), EXECUTION_ID BIGINT NOT NULL, CONSTRAINT "SCRIPTED_EXECUTION_EXTENDER_pkey" PRIMARY KEY (SCRIPTED_EXECUTION_EXTENDER_ID), CONSTRAINT fk_scripted_extender_execution FOREIGN KEY (EXECUTION_ID) REFERENCES EXECUTION(EXECUTION_ID));

COMMENT ON COLUMN SCRIPTED_EXECUTION_EXTENDER.SCRIPTED_EXECUTION_EXTENDER_ID IS 'autogenerated ID';

COMMENT ON COLUMN SCRIPTED_EXECUTION_EXTENDER.LANGUAGE IS 'scriptLanguage of script';

COMMENT ON COLUMN SCRIPTED_EXECUTION_EXTENDER.SCRIPT_NAME IS 'script name,by example feature name for Gherkin';

COMMENT ON COLUMN SCRIPTED_EXECUTION_EXTENDER.EXECUTION_ID IS 'foreign key to EXECUTION';

CREATE INDEX scripted_execution_extender_execution_id_idx ON SCRIPTED_EXECUTION_EXTENDER(EXECUTION_ID);

ALTER TABLE TEST_CASE ADD TC_KIND VARCHAR(30) DEFAULT 'STANDARD' NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-scripted-test-case', 'jthebault', '../tm/tm.changelog-1.18.0.xml', NOW(), 10, '8:d5249b00e7375b24091e878316a2492b', 'createTable tableName=SCRIPTED_TC_EXTENDER; createIndex indexName=scripted_tc_extender_test_case_id_idx, tableName=SCRIPTED_TC_EXTENDER; createTable tableName=SCRIPTED_EXECUTION_EXTENDER; createIndex indexName=scripted_execution_extender_execution...', 'Create the scripted test case table
Create the scripted execution table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-modification-report::zyang
-- Adds a summary field to report definition
ALTER TABLE REPORT_DEFINITION ADD SUMMARY VARCHAR(255) DEFAULT '' NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-modification-report', 'zyang', '../tm/tm.changelog-1.18.0.xml', NOW(), 11, '8:d18f312340f2a9695467f8b970bd18c4', 'addColumn tableName=REPORT_DEFINITION', 'Adds a summary field to report definition', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-oauth1a-consumer-1::bsiri
-- StoredCredentials can now store either credentials, either general configuration.
--         A new column appear so we can hint what is the type of the payload.
--         Also, users can now have stored credentials (even though they can't manage them yet).
--         Only one credentials can be created for a given user and a given server (bugtracker)
ALTER TABLE STORED_CREDENTIALS ADD CONTENT_TYPE VARCHAR(4) DEFAULT 'CRED';

ALTER TABLE STORED_CREDENTIALS ADD AUTHENTICATED_USER BIGINT DEFAULT null;

ALTER TABLE STORED_CREDENTIALS ADD CONSTRAINT fk_stored_credentials_user FOREIGN KEY (AUTHENTICATED_USER) REFERENCES CORE_USER (PARTY_ID);

COMMENT ON COLUMN STORED_CREDENTIALS.CONTENT_TYPE IS 'the role of the content, either CRED or CONF';

COMMENT ON COLUMN STORED_CREDENTIALS.AUTHENTICATED_USER IS 'Foreign key to the user account that owns the credentials. A NULL value means that Squash-TM               owns the credentials (app-level credentials).';

ALTER TABLE STORED_CREDENTIALS ADD CONSTRAINT uniq_stored_credentials_server_user UNIQUE (AUTHENTICATED_SERVER, AUTHENTICATED_USER, CONTENT_TYPE);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-oauth1a-consumer-1', 'bsiri', '../tm/tm.changelog-1.18.0.xml', NOW(), 12, '8:40cf2cb2853a3de0486875b356e99208', 'addColumn tableName=STORED_CREDENTIALS; addUniqueConstraint constraintName=uniq_stored_credentials_server_user, tableName=STORED_CREDENTIALS', 'StoredCredentials can now store either credentials, either general configuration.
        A new column appear so we can hint what is the type of the payload.
        Also, users can now have stored credentials (even though they can''t manage them y...', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-oauth1a-consumer-2::bsiri
-- Bugtracker now declare which authentication protocol should be used upfront.
ALTER TABLE BUGTRACKER ADD AUTH_PROTOCOL VARCHAR(30) DEFAULT 'BASIC_AUTH' NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-oauth1a-consumer-2', 'bsiri', '../tm/tm.changelog-1.18.0.xml', NOW(), 13, '8:7ef0a187573741b67e5c7d67d737ca66', 'addColumn tableName=BUGTRACKER', 'Bugtracker now declare which authentication protocol should be used upfront.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Changeset ../tm/tm.changelog-1.18.0.xml::tm-1.18.0-email-column-resizing::aguilhem
ALTER TABLE CORE_USER ALTER COLUMN EMAIL TYPE VARCHAR(255) USING (EMAIL::VARCHAR(255));

ALTER TABLE CORE_USER ALTER COLUMN  EMAIL SET DEFAULT '';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.18.0-email-column-resizing', 'aguilhem', '../tm/tm.changelog-1.18.0.xml', NOW(), 14, '8:1459ae06e7ed1049f85d05dba10c783a', 'modifyDataType columnName=EMAIL, tableName=CORE_USER; addDefaultValue columnName=EMAIL, tableName=CORE_USER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187761');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

