-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.21.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.21.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0::jprioux
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.21.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0', 'jprioux', '../tm/tm.changelog-1.21.0.xml', NOW(), 2, '8:eb3feb01de277a67ff0cd5e29967db76', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-244-remote-automation-request-extender::jlor
-- Create new table for RemoteAutomationRequestExtender
CREATE TABLE REMOTE_AUTOMATION_REQUEST_EXTENDER (REMOTE_AUTOMATION_REQUEST_EXTENDER_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, AUTOMATION_REQUEST_ID BIGINT NOT NULL, SERVER_ID BIGINT, REMOTE_STATUS VARCHAR(255), REMOTE_ISSUE_KEY VARCHAR(255) NOT NULL, REMOTE_REQUEST_URL VARCHAR(300), REMOTE_ASSIGNED_TO VARCHAR(300) NOT NULL, CONSTRAINT "REMOTE_AUTOMATION_REQUEST_EXTENDER_pkey" PRIMARY KEY (REMOTE_AUTOMATION_REQUEST_EXTENDER_ID), CONSTRAINT fk_remote_automation_request_extender_server_id FOREIGN KEY (SERVER_ID) REFERENCES BUGTRACKER (BUGTRACKER_ID), CONSTRAINT fk_remote_automation_request_extender_automation_request_id FOREIGN KEY (AUTOMATION_REQUEST_ID) REFERENCES AUTOMATION_REQUEST (AUTOMATION_REQUEST_ID));

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.REMOTE_AUTOMATION_REQUEST_EXTENDER_ID IS 'The auto-generated id';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.AUTOMATION_REQUEST_ID IS 'The automation request this extender extends';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.SERVER_ID IS 'The bugtracker to which the automation request is linked';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.REMOTE_STATUS IS 'The remote status as defined in the bugtracker';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.REMOTE_ISSUE_KEY IS 'The remote issue key as generated by Jira';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.REMOTE_REQUEST_URL IS 'The Url to the remote request';

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.REMOTE_ASSIGNED_TO IS 'email of the assigned';

CREATE INDEX idx_fk_remote_automation_request_extender_automation_request_id ON REMOTE_AUTOMATION_REQUEST_EXTENDER(AUTOMATION_REQUEST_ID);

CREATE INDEX idx_fk_remote_automation_request_extender_server_id ON REMOTE_AUTOMATION_REQUEST_EXTENDER(SERVER_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-244-remote-automation-request-extender', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 3, '8:d884d1b527d71e6732d90ae44a006dfe', 'createTable tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER; createIndex indexName=idx_fk_remote_automation_request_extender_automation_request_id, tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER; createIndex indexName=idx_fk_remote_automation_request_e...', 'Create new table for RemoteAutomationRequestExtender', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-248-automation-workflow-type::jlor
-- Modify column ALLOW_AUTOMATION_WORKFLOW into AUTOMATION_WORKFLOW_TYPE
ALTER TABLE PROJECT ADD AUTOMATION_WORKFLOW_TYPE VARCHAR(25) DEFAULT 'NONE' NOT NULL;

COMMENT ON COLUMN PROJECT.AUTOMATION_WORKFLOW_TYPE IS 'This column precises which workflow type is used.';

update PROJECT
      set AUTOMATION_WORKFLOW_TYPE =
      case
      when ALLOW_AUTOMATION_WORKFLOW = true then 'NATIVE'
      else 'NONE'
      end;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-248-automation-workflow-type', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 4, '8:929763da9d90be57088f04868ad02201', 'addColumn tableName=PROJECT; sql', 'Modify column ALLOW_AUTOMATION_WORKFLOW into AUTOMATION_WORKFLOW_TYPE', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-248-plugin-type::amk
-- add new column PLUGIN_TYPE into LIBRARY_PLUGIN_BINDING
ALTER TABLE LIBRARY_PLUGIN_BINDING ADD PLUGIN_TYPE VARCHAR(25);

COMMENT ON COLUMN LIBRARY_PLUGIN_BINDING.PLUGIN_TYPE IS 'This column specifies which type of plugin is used. for now only one type used: Automation.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-248-plugin-type', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 5, '8:4d58d15572c268a50ac2fbddbec509f9', 'addColumn tableName=LIBRARY_PLUGIN_BINDING', 'add new column PLUGIN_TYPE into LIBRARY_PLUGIN_BINDING', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-211-active::amk
-- add new column ACTIVE into LIBRARY_PLUGIN_BINDING
ALTER TABLE LIBRARY_PLUGIN_BINDING ADD ACTIVE BOOLEAN DEFAULT TRUE;

COMMENT ON COLUMN LIBRARY_PLUGIN_BINDING.ACTIVE IS 'This column specifies if plugin is enable or disable for a project .';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-211-active', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 6, '8:240329fdd9d27baee14fd0958332c569', 'addColumn tableName=LIBRARY_PLUGIN_BINDING', 'add new column ACTIVE into LIBRARY_PLUGIN_BINDING', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-649-sync-enable::api
-- add new column Sync_Enable into REMOTE_SYNCHONISATION
ALTER TABLE REMOTE_SYNCHRONISATION ADD SYNC_ENABLE BOOLEAN DEFAULT TRUE NOT NULL;

COMMENT ON COLUMN REMOTE_SYNCHRONISATION.SYNC_ENABLE IS 'This column specifies if synchronisation is enable or disable for a project';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-649-sync-enable', 'api', '../tm/tm.changelog-1.21.0.xml', NOW(), 7, '8:57636328da4d9f5b75fab99241fa5eb4', 'addColumn tableName=REMOTE_SYNCHRONISATION', 'add new column Sync_Enable into REMOTE_SYNCHONISATION', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-211-last-sync-date::amk
-- add new column LAST-SYNC-DATE into REMOTE_AUTOMATION_REQUEST_EXTENDER
ALTER TABLE REMOTE_AUTOMATION_REQUEST_EXTENDER ADD LAST_SYNC_DATE TIMESTAMP WITHOUT TIME ZONE DEFAULT null;

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.LAST_SYNC_DATE IS 'Date of the last synchronisation.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-211-last-sync-date', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 8, '8:07cf71a79269ade079ea39832560652a', 'addColumn tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER', 'add new column LAST-SYNC-DATE into REMOTE_AUTOMATION_REQUEST_EXTENDER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-725-add-committer-mail-in-scm-server::jlor
-- Add column COMMITTER_MAIL in SCM_SERVER
ALTER TABLE SCM_SERVER ADD COMMITTER_MAIL VARCHAR(255) DEFAULT '' NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-725-add-committer-mail-in-scm-server', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 9, '8:e051e8ad2d2a6220a258ad3240ebf823', 'addColumn tableName=SCM_SERVER', 'Add column COMMITTER_MAIL in SCM_SERVER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-713-add-axis_and_measure-to-execution_is_auto::abo
INSERT INTO CHART_COLUMN_ROLE (CHART_COLUMN_ID, ROLE) values ((SELECT QUERY_COLUMN_ID FROM QUERY_COLUMN_PROTOTYPE WHERE QUERY_COLUMN_PROTOTYPE.LABEL = 'EXECUTION_ISAUTO'), 'MEASURE'),
      ((SELECT QUERY_COLUMN_ID FROM QUERY_COLUMN_PROTOTYPE WHERE QUERY_COLUMN_PROTOTYPE.LABEL = 'EXECUTION_ISAUTO'), 'AXIS');

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-713-add-axis_and_measure-to-execution_is_auto', 'abo', '../tm/tm.changelog-1.21.0.xml', NOW(), 10, '8:081013621cd9074ccda595855ece98c2', 'sql', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-211-sent-value-for-sync::amk
-- add new column SENT_VALUE_FOR_SYNC into REMOTE_AUTOMATION_REQUEST_EXTENDER
ALTER TABLE REMOTE_AUTOMATION_REQUEST_EXTENDER ADD SENT_VALUE_FOR_SYNC TEXT DEFAULT null;

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.SENT_VALUE_FOR_SYNC IS 'The values ​​of the test case fields sent during synchronization.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-211-sent-value-for-sync', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 11, '8:2ef2dfed74f847f837a5b81aa7025619', 'addColumn tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER', 'add new column SENT_VALUE_FOR_SYNC into REMOTE_AUTOMATION_REQUEST_EXTENDER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-916-918-synchronizable-issue-status::amk
-- add new column SYNCHRONIZABLE_ISSUE_STATUS into REMOTE_AUTOMATION_REQUEST_EXTENDER
ALTER TABLE REMOTE_AUTOMATION_REQUEST_EXTENDER ADD SYNCHRONIZABLE_ISSUE_STATUS VARCHAR(25);

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.SYNCHRONIZABLE_ISSUE_STATUS IS 'this column can be set to: TO SYNCHRONIZE, DELETED, MOVED_PROJECT and MOVED_ISSUE_TYPE ; and it is updated after each synchronization.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-916-918-synchronizable-issue-status', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 12, '8:cd8dc13f182fe565a72a4c00d95763c6', 'addColumn tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER', 'add new column SYNCHRONIZABLE_ISSUE_STATUS into REMOTE_AUTOMATION_REQUEST_EXTENDER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-875-last-sync-date-squash::amk
-- add new column LAST-SYNC-DATE into REMOTE_AUTOMATION_REQUEST_EXTENDER
ALTER TABLE REMOTE_AUTOMATION_REQUEST_EXTENDER ADD LAST_SYNC_DATE_SQUASH TIMESTAMP WITHOUT TIME ZONE DEFAULT null;

COMMENT ON COLUMN REMOTE_AUTOMATION_REQUEST_EXTENDER.LAST_SYNC_DATE_SQUASH IS 'Date of the last synchronisation squash to remote server.';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-875-last-sync-date-squash', 'amk', '../tm/tm.changelog-1.21.0.xml', NOW(), 13, '8:caa74bc72f5abd3467117e5ba0887a01', 'addColumn tableName=REMOTE_AUTOMATION_REQUEST_EXTENDER', 'add new column LAST-SYNC-DATE into REMOTE_AUTOMATION_REQUEST_EXTENDER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-846.1-postgresql::jlor
-- PostgreSQL - Add unique constraint on order column for iterations in campaign
drop table if exists CAMPAIGN_ITERATION_TMP;

create table CAMPAIGN_ITERATION_TMP AS
          (select
            CAMPAIGN_ID,
            ITERATION_ID,
            min(ITERATION_ORDER) ITERATION_ORDER
          from CAMPAIGN_ITERATION
          group by CAMPAIGN_ID, ITERATION_ID);

create index idx1 on CAMPAIGN_ITERATION_TMP(CAMPAIGN_ID, ITERATION_ID);

update CAMPAIGN_ITERATION_TMP t1
        set ITERATION_ORDER = t2.line - 1
        from (
          select
            CAMPAIGN_ID,
            ITERATION_ID,
            (select count(*)
            from CAMPAIGN_ITERATION_TMP b
            where a.CAMPAIGN_ID = b.CAMPAIGN_ID
            and a.ITERATION_ORDER >= b.ITERATION_ORDER) line
          from CAMPAIGN_ITERATION_TMP a) t2
          where t1.CAMPAIGN_ID = t2.CAMPAIGN_ID
          and t1.ITERATION_ID = t2.ITERATION_ID;

truncate table CAMPAIGN_ITERATION;

insert into CAMPAIGN_ITERATION
        select
          a.CAMPAIGN_ID,
          a.ITERATION_ID,
          a.ITERATION_ORDER + 1 - (select count(*)
                              from CAMPAIGN_ITERATION_TMP b
                              where a.CAMPAIGN_ID = b.CAMPAIGN_ID
                              and a.ITERATION_ORDER = b.ITERATION_ORDER
                              and a.ITERATION_ID <= b.ITERATION_ID
                              group by
                                b.CAMPAIGN_ID,
                                b.ITERATION_ORDER) ITERATION_ORDER
          from CAMPAIGN_ITERATION_TMP a;

drop table CAMPAIGN_ITERATION_TMP;

ALTER TABLE CAMPAIGN_ITERATION ADD UNIQUE (CAMPAIGN_ID, ITERATION_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-846.1-postgresql', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 14, '8:34d773392fe294be9643420ed8b79a65', 'sql; addUniqueConstraint tableName=CAMPAIGN_ITERATION', 'PostgreSQL - Add unique constraint on order column for iterations in campaign', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-846.2-postgresql::jlor
-- PostgreSQL - Add unique constraint on order column for executions in itpi
drop table if exists ITEM_TEST_PLAN_EXECUTION_TMP;

create table ITEM_TEST_PLAN_EXECUTION_TMP AS
          (select
            ITEM_TEST_PLAN_ID,
            EXECUTION_ID,
            min(EXECUTION_ORDER) EXECUTION_ORDER
          from ITEM_TEST_PLAN_EXECUTION
          group by ITEM_TEST_PLAN_ID, EXECUTION_ID);

create index idx1 on ITEM_TEST_PLAN_EXECUTION_TMP(ITEM_TEST_PLAN_ID, EXECUTION_ID);

update ITEM_TEST_PLAN_EXECUTION_TMP t1
        set EXECUTION_ORDER = t2.line - 1
        from (
          select
            ITEM_TEST_PLAN_ID,
            EXECUTION_ID,
            (select count(*)
            from ITEM_TEST_PLAN_EXECUTION_TMP b
            where a.ITEM_TEST_PLAN_ID = b.ITEM_TEST_PLAN_ID
            and a.EXECUTION_ORDER >= b.EXECUTION_ORDER) line
          from ITEM_TEST_PLAN_EXECUTION_TMP a) t2
          where t1.ITEM_TEST_PLAN_ID = t2.ITEM_TEST_PLAN_ID
          and t1.EXECUTION_ID = t2.EXECUTION_ID;

truncate table ITEM_TEST_PLAN_EXECUTION;

insert into ITEM_TEST_PLAN_EXECUTION
        select
          a.ITEM_TEST_PLAN_ID,
          a.EXECUTION_ID,
          a.EXECUTION_ORDER + 1 - (select count(*)
                              from ITEM_TEST_PLAN_EXECUTION_TMP b
                              where a.ITEM_TEST_PLAN_ID = b.ITEM_TEST_PLAN_ID
                              and a.EXECUTION_ORDER = b.EXECUTION_ORDER
                              and a.EXECUTION_ID <= b.EXECUTION_ID
                              group by
                                b.ITEM_TEST_PLAN_ID,
                                b.EXECUTION_ORDER) EXECUTION_ORDER
          from ITEM_TEST_PLAN_EXECUTION_TMP a;

drop table ITEM_TEST_PLAN_EXECUTION_TMP;

ALTER TABLE ITEM_TEST_PLAN_EXECUTION ADD UNIQUE (ITEM_TEST_PLAN_ID, EXECUTION_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-846.2-postgresql', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 15, '8:7a25db2a41238b49f55dba2493458374', 'sql; addUniqueConstraint tableName=ITEM_TEST_PLAN_EXECUTION', 'PostgreSQL - Add unique constraint on order column for executions in itpi', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-846.3-postgresql::jlor
-- PostgreSQL - Add unique constraint on order column for steps in execution
drop table if exists EXECUTION_EXECUTION_STEPS_TMP;

create table EXECUTION_EXECUTION_STEPS_TMP AS
          (select
            EXECUTION_ID,
            EXECUTION_STEP_ID,
            min(EXECUTION_STEP_ORDER) STEP_ORDER
          from EXECUTION_EXECUTION_STEPS
          group by EXECUTION_ID, EXECUTION_STEP_ID);

create index idx1 on EXECUTION_EXECUTION_STEPS_TMP(EXECUTION_ID, EXECUTION_STEP_ID);

update EXECUTION_EXECUTION_STEPS_TMP t1
        set STEP_ORDER = t2.line - 1
        from (
          select
            EXECUTION_ID,
            EXECUTION_STEP_ID,
            (select count(*)
            from EXECUTION_EXECUTION_STEPS_TMP b
            where a.EXECUTION_ID = b.EXECUTION_ID
            and a.STEP_ORDER >= b.STEP_ORDER) line
          from EXECUTION_EXECUTION_STEPS_TMP a) t2
          where t1.EXECUTION_ID = t2.EXECUTION_ID
          and t1.EXECUTION_STEP_ID = t2.EXECUTION_STEP_ID;

truncate table EXECUTION_EXECUTION_STEPS;

insert into EXECUTION_EXECUTION_STEPS
        select
          a.EXECUTION_ID,
          a.EXECUTION_STEP_ID,
          a.STEP_ORDER + 1 - (select count(*)
                              from EXECUTION_EXECUTION_STEPS_TMP b
                              where a.EXECUTION_ID = b.EXECUTION_ID
                              and a.STEP_ORDER = b.STEP_ORDER
                              and a.EXECUTION_STEP_ID <= b.EXECUTION_STEP_ID
                              group by
                                b.EXECUTION_ID,
                                b.STEP_ORDER) STEP_ORDER
          from EXECUTION_EXECUTION_STEPS_TMP a;

drop table EXECUTION_EXECUTION_STEPS_TMP;

ALTER TABLE EXECUTION_EXECUTION_STEPS ADD UNIQUE (EXECUTION_ID, EXECUTION_STEP_ORDER);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-846.3-postgresql', 'jlor', '../tm/tm.changelog-1.21.0.xml', NOW(), 16, '8:f371d23f5944f1d368a499a43c1aa522', 'sql; addUniqueConstraint tableName=EXECUTION_EXECUTION_STEPS', 'PostgreSQL - Add unique constraint on order column for steps in execution', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Changeset ../tm/tm.changelog-1.21.0.xml::tm-1.21.0-TM-996-modify-entity-reference-id-type::jprioux
-- Modify ENTITY_REFERENCE_ID data type in CHART_SCOPE
ALTER TABLE CHART_SCOPE ALTER COLUMN ENTITY_REFERENCE_ID TYPE BIGINT USING (ENTITY_REFERENCE_ID::BIGINT);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.21.0-TM-996-modify-entity-reference-id-type', 'jprioux', '../tm/tm.changelog-1.21.0.xml', NOW(), 17, '8:4820a152f32a0acb2441cd5c55d5e2a6', 'modifyDataType columnName=ENTITY_REFERENCE_ID, tableName=CHART_SCOPE', 'Modify ENTITY_REFERENCE_ID data type in CHART_SCOPE', 'EXECUTED', NULL, NULL, '4.17.2', '9340187895');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

